function  s = addbabylon(a,b)
% s = addbabylon(a,b)
% Addition fr beliebig grosse Zahlen in linearer 
% babylonischer Zahlendarstellung im Sexagesimalsystem.
% Siehe num2babylon

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Wandlung der Babylonischen Ziffern von Operand a in Zahlen
% ==========================================================
s = a;
k = 1;
while length(s)>0
   zz = 0;
   s1 = s(1);
   s  = s(2:end);
   while s1~=' '
      if s1=='<' zz = zz + 10; end
      if s1=='1' zz = zz + 1;  end
      if length(s)>0
         s1 = s(1);
         s  = s(2:end);
      else
         s1 = ' ';
      end
   end
   if zz==0  s = s(2:end); end
   z(k) = zz;
   k = k + 1;
end
az = reverse(z);                           % Ziffern von a

% Wandlung der Babylonischen Ziffern von Operand b in Zahlen
% ==========================================================
z = [];
s = b;
k = 1;
while length(s)>0
   zz = 0;
   s1 = s(1);
   s  = s(2:end);
   while s1~=' '
      if s1=='<' zz = zz + 10; end
      if s1=='1' zz = zz + 1;  end
      if length(s)>0
         s1 = s(1);
         s  = s(2:end);
      else
         s1 = ' ';
      end
   end
   if zz==0  s = s(2:end); end
   z(k) = zz;
   k = k + 1;
end
bz = reverse(z);                           % Ziffern von b

% Angleichung der Lnge der Zahlendarstellung durch fhrende Nullen
% =================================================================
la = length(az);
lb = length(bz);
if la>lb
   az = [az 0];
   bz = [bz zeros(1,1+la-lb)];
else
   bz = [bz 0];
   az = [az zeros(1,1+lb-la)];
end

% Summe durch seriellen Addierer
% ==============================
c = 0;
for k=1:length(az)
   [ss(k) c] = fulladd(az(k),bz(k),c,60);  % serielle Addition 
end

% Wandlung der Zahlenziffern in babylonische Schreibweise
% =======================================================
bv = reverse (ss);
s = '';
for k=1:length(bv)
   nz = floor(bv(k)/10);
   ne = rem(bv(k),10);
   for i=1:nz   s = [s '<']; end
   for i=1:ne   s = [s '1']; end
   if bv(k)==0  s = [s ' ']; end
   s = [s ' '];
end

s = s(1:end-1);



