function  asciimat(font)
% asciimat(font)
% gibt eine ASCII-Tabelle in Matrixform in ein Diagramm

% Default
% =======
if nargin<1  font = 'Times'; end

% Konstanten
% ==========
dx = 0.15;  fx = 0.05;
dy = 0.81;  fy = 0.05;
xt = 0.08;
yt = 0.90;
scrs = get(0,'ScreenSize');
fsiz = round(17/1024*scrs(3));                   % FontSize
fwgt = 'demi';
alx = 0.05;
elx = 0.92;
aly = 0.04;
ely = 0.95;
lpy = 0.86;
lpx = 0.12;
lwl = 2;
symb = '0123456789ABCDEF';
helptxt = {'Hilfe zu ASCIIMAT:';
           'Anklicken eines Symbols liefert seine Codierung';
           'Anklicken des FontNamen liefert das Font-Auswahlfenster'}';

% Bild und Achsen
% ===============
fh = fullscreen('ASCII');
set(fh,'KeyPressFcn','helpfcn')
ax = axes('Position',[0 0 1 1]);
axis([0 1 0 1]); axis off

% Tabelle
% =======
for i=0:15
   for j=0:15
      text(dx+fx*j,dy-fy*i,char(16*j+i),'Interpreter','none','FontSize',fsiz,...
           'FontName',font,'FontWeight',fwgt,'ButtonDownFcn','asciimatbdf','UserData',16*j+i); 
   end   
end

% Beschriftung
% ============
line([alx lpx; elx lpx],[lpy aly; lpy ely],'LineWidth',lwl,'Color','b')
for j=0:15
   text(dx+fx*j,yt,symb(j+1),'FontSize',fsiz,'FontName','FixedWidth',...
        'FontWeight',fwgt,'Color','b','UserData','Font');
end
for i=0:15
   text(xt,dy-fy*i,symb(i+1),'FontSize',fsiz,'FontName','FixedWidth',...
        'FontWeight',fwgt,'Color','b','UserData','Font');
end
text(lpx-0.01,yt,font,'FontSize',fsiz,'Color','b','HorizontalAlignment','right',...
     'ButtonDownFcn','asciimatbdf','UserData','Font')

% Interaktiver Text
% =================
th = text(0.35,0.96,'bin       hex  dez','FontSize',fsiz+5,'FontName','FixedWidth',...
          'FontWeight',fwgt,'Color','r','UserData','Font');
fud.data = [th th];
fud.helptext = helptxt;       
set(fh,'UserData',fud)