function s = binrep2str(x,a)
% s = binrep2str(x,a)
% Wandlung einer mit  x = str2binrep(s,a)  komprimierten 
% binren Reprsentation x des Strings s zurck nach s. 
% a ist ein String, der die in s erlaubten Symbole in 
% der Reihenfolge enthlt, wie sie binr kodiert werden
% sollen.
% Werden an den Stellen von s verschiedene Alphabete 
% benutzt, so ist a als ein Cell Array anzugeben, das 
% pro Stelle von s den entsprechenden String der 
% erlaubten Symbole enthlt.

if nargin<2  a = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789.,?/#$'; end
if nargin<1  x = str2binrep('TEST 007',a); end
zz = binvec2num(x);

if iscell(a)
   for k=1:length(a)
      na   = length(a{k});
      z(k) = rem(zz,na) + 1;
      zz   = floor(zz/na);
      s(k) = a{k}(z(k));
   end
else
   lx = length(x);
   na = length(a);
   for k=1:floor(length(x)/log2(length(a)))
      z(k) = rem(zz,na) + 1;
      zz   = floor(zz/na);
   end
   s = a(z);
end