function b = checkkvmin(binexp,ftab,variable,na,no)
% b = checkkvmin(binexp,ftab,variable,na,no)
% berprfung der Minimierung mit dem KV-Diagramm:
% binexp   :  String mit dem zu prfenden Ausdruck in MATLAB-Syntax
% ftab     :  Funktionstabelle der zu realisierenden Schaltfunktion
% variable :  Cell array mit den Variablen als Strings
% na       :  Anzahl der UND-Verknpfungen des minimierten Ausdrucks
% no       :  Anzahl der ODER-Verknpfungen des minimierten Ausdrucks

% Autor:  Klaus von der Heide, e-mail:  v.d.heide@on-line.de

ft   = binexp2bintab(binexp,variable);
fok  = all((ft==ftab)|(ftab<0));
nar  = sum(binexp=='&');
nor  = sum(binexp=='|');

if fok & nar<=na & nor<=no  
   sprintf('\n\n   korrekte Lsung!\n\n')
   if nar<na | nor<no  sprintf('\n   die Lsung ist besser als die Vergleichslsung!\n\n'); end
   break
end

if ~fok
   if isdisjunctive(binexp)
      sprintf('\n\n   Wenigstens ein Einspunkt liegt ausserhalb oder ein Nullpunkt innerhalb der Schleifen!\n\n')
   elseif isconjunctive(binexp)
      sprintf('\n\n   Wenigstens ein Nullpunkt liegt ausserhalb oder ein Einspunkt innerhalb der Schleifen!\n\n')
   end
end

if nar>na | nor>no
   sprintf('\n\n   Der Ausdruck kann weiter minimiert werden!\n\n')
end

