function distributivzahl
% distributivzahl
% Interaktive Darstellung des Ursprungs der Zahl.

% Autor:  Klaus von der Heide, e-mail:  v.d.heide@on-line.de

% Konstanten
% ==========
scrs = get(0,'ScreenSize');
fsiz = round(15/1024*scrs(3));                   % FontSize

txt  = {'+';                                     % Texte
        '='};
     
ustr = {'Kartoffeln';                            % UI-Strings
        'Kartoffeln';
        'Kartoffeln';
        '2';
        '3';
        '5';
        'Abstraktion'};
     
helptxt = {'Hilfe zu distributivzahl:';          % Hilfetext
           'Die Inhalte der Fenster links vom =Zeichen';
           'knnen nach Klick editiert werden und';
           'mit der Eingabetaste abgeschlossen werden.';
           'Die kleinen Fenster sind numerisch.'};
     
tpos = 0.05*[7.5  12.5];                         % Position der Texte
        
upos = 0.05*[ 4  9  3  2;                        % Position der UIs
              9  9  3  2; 
             14  9  3  2;
              3  9  1  2;
              8  9  1  2;
             13  9  1  2;
              8  0  4  4];
      
% Bild und Achsen
% ===============
fh = fullscreen('Ursprung','w',0,[3 1; 3 1]);    % Schirmbild
ax = axes('Position',[0 0 1 1]);                 % Ganzbild-Achsen
axis([0 1 0 1 ]); axis off                       % Einheiten

% Graue Flche
% ============
ph = patch([0 1 1 0],[0 0 1 1],0.7*[1 1 1]);

% Texte
% =====
for k=1:length(txt)
   text(tpos(k),0.5,txt{k},'HorizontalAlignment','center','VerticalAlignment','middle','FontSize',fsiz);
end

% Interaktivitt
% ==============
for k=1:6
   uih(k) = uicontrol(fh,'Units','normalized','Position',upos(k,:),'String',ustr{k},'Style','edit',...
                      'FontSize',fsiz,'FontName','FixedWidth',...
                      'CallBack','distributivzahlfcn','BackgroundColor',[1 1 1]);
end
uih(7) = uicontrol(fh,'Units','normalized','Position',upos(7,:),'String',ustr{7},'Style','togglebutton',...
                   'FontSize',fsiz,'FontName','FixedWidth',...
                   'CallBack','distributivzahlfcn','BackgroundColor','g');
               
% UserData des Fensters fr die Interaktivitt
% ============================================
fud.helptext = helptxt;
fud.handles  = uih;
fud.data     = ustr;
set(fh,'UserData',fud,'KeyPressFcn','helpfcn');
