function drawbus(n)
% drawbus(n)
% Schema eines Busses mit n Zugngen

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Default
% =======
if nargin<1  n = 4; end

% Konstanten
% ==========
fsiz = 16;
lw   = 2;
pcol = 0.9*[1 1 1];
lcol = 'k';
inc  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdef';
while length(inc)<n  inc = [inc inc]; end

% Bild und Achsen
% ===============
fh  = fullscreen('BUS','w',0,[0 1 0.5 1]);
axes('Position',[0 0 1 1])
axis([0 10*n+2 -1 13]);  axis off

% Graphik
% =======
bh = line([0 10*n+2],[0 0],'LineWidth',3,'Color',lcol);
for k=1:n
   h  = patch(10*k-7.5+[0 6 6 0],6+[0 0 6 6],pcol);
   text(10*k-4.5,9,inc(k),'FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle')
   bh = [bh line(10*k-6+[0 3],[0 0],'LineStyle','none','Marker','.','MarkerSize',30,'Color',lcol)];   
   bh = [bh drawarr([10*k-3 0],[10*k-3 6],lcol,2,0.5)];
   bh = [bh line(10*k-6+[0 0 0.3],[0 2 2],'LineWidth',lw,'Color',lcol)];
   h  = [h line(10*k-6,4,'LineStyle','none','Marker','o','MarkerSize',8,'Color','k')];
   h  = [h drawarr([10*k-6 6],[10*k-6 4.2],lcol,2,0.5)];
   h  = [h line(10*k-6+[0.1 1],[3.8 2],'LineWidth',lw,'Color',lcol)];
   h  = [h line(10*k-6+[0 0.2],[3.8 2],'LineWidth',lw,'Color',lcol,'Visible','off')];
   hd{k} = h;
end

% Interaktion
% ===========
for k=1:n
   ud.h   = hd{k};
   ud.on  = hd{k}(end);
   ud.off = hd{k}(end-1);
   bdf{1} = 'ud = get(gco,''UserData''); '; 
   bdf{2} = 'if strcmp(get(ud.on,''Visible''),''off'')  an = ''on''; else an = ''off''; end; ';
   bdf{3} = 'set(ud.on,''Visible'',an); '; 
   bdf{4} = 'if strcmp(an,''on'') set(ud.off,''Visible'',''off''); else set(ud.off,''Visible'',''on''); end; '; 
   bdfcn  = cat(2,bdf{:});
   set(hd{k},'UserData',ud,'ButtonDownFcn',bdfcn)
end

