function drawff(pos)
% drawff(pos)
% Graphik eines allgemeinen Flipflopmodells.
% pos :  Position-property der Achsen, die fr die Graphik in ein 
%        vorhandenes Bild eingefgt werden.
%        Ist pos nicht angegeben, so wird ein neues Bild erzeugt.

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Konstanten
% ==========
fsiz = 16;
pcol = 0.9*[1 1 1];
lcol = 0.8*[1 1 1];

% Bilderzeugung falls ntig
% =========================
if nargin <1  
   fh  = fullscreen('FF','w',0,[0 0.23 0.6 1]);
   pos = [0 0 1 1];
end
axes('Position',pos)
axis([0 16 0 16]);  axis off

% Graphik
% =======
patch([ 6 10 10  6],[ 6  6 14 14],pcol);
drawarr([1.5 10],[ 6   10],'k',2.5,1);
drawarr([10  10],[14.5 10],'k',2.5,1);
drawarr([ 8   2],[ 8    6],'k',2.5,1);
text( 3,11,'Input',   'FontSize',fsiz,'HorizontalAlignment','center')
text(12.5,11,'Output','FontSize',fsiz,'HorizontalAlignment','center')
text(8.5,3,'Takt',    'FontSize',fsiz)
