function drawfsmkpf
% drawfsmkpf
% keypressfcn fr drawfsm

% Konstanten
% ==========
lw = 1.5;                   % LineWidth
nc = 0.7*[1 1 1];           % Knoten-Farbe
sc = 'g';                   % Farbe selektierter Knoten
nl = 'k';                   % Kanten-Farbe
sl = 'r';                   % Farbe selektierter Kanten
cfg = gcf;                  % Figure Handle
fud = get(cfg,'UserData');  % UserData
cc  = get(cfg,'CurrentCharacter'); % zuletzt eingegebener Buchstabe

% Interaktion
% ===========
switch cc
case {'T','t','C','c','N','n'}
   nexts = fud.stab(fud.currs,fud.currx);
   if nexts>0
      fud.currs = nexts;
   else
      sound(sin(2*pi*0.125*(0:1000)),8000) % Ton bei Falscheingabe
      break
   end
case {'h','H'}
   fsiz = 13;
   fud = get(cfg,'UserData');
   nz = length(fud.helptext);
   fh = fullscreen('Hilfe','w',0,[0 0.5 0 1]);
   set(fh,'ButtonDownFcn','delete(gcf)')
   axes('Position',[0.1 0.1 0.8 0.8])
   axis([0 1 -nz 2])
   axis off
   text(0,-nz/2,fud.helptext,'FontSize',fsiz)
case {'0','1','2','3','4','5','6','7','8','9'}
   ccn = str2num(cc);
   [ns,nx] = size(fud.stab);
   if ccn==0 | ccn>nx | fud.stab(fud.currs,ccn)<1  
      sound(sin(2*pi*0.125*(0:1000)),8000) % Ton bei Falscheingabe
      break
   else
      fud.currx = ccn;                     % neuer Inputindex 
   end
end

% Graphik ndern
% ==============
set(cfg,'UserData',fud);                   % Update UserData
drawfsmupdate(cfg)                         % Update der Graphik

% Assoziierte Graphik ndern
% ==========================
if ~isempty(fud.fig)
   try
      fudfig = get(fud.fig,'UserData');
      fudfig.currs = fud.currs;
      fudfig.currx = fud.currx;
      set(fud.fig,'UserData',fudfig);      % Update UserData
      fsmtabupdate(fud.fig)                % Update der Graphik
   end
end

if double(cc)==27  msvdelfig;   end        % delete all
if double(cc)==127 delete(gcf); end        % delete

