function drawjkff
% drawjkff
% Graphik des J-K-Flipflops als getaktetes Schaltwerk.

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Konstanten
% ==========
fsz = 15;               % FontSize
ms  = 18;               % MarkerSize
msn = 30;               % MarkerSize fr Negation
lw  = 1.2;              % LineWidth
col = 'k';              % Color

% Fenster
% =======
fh = fullscreen('J-K-FF','w',0,[2 3; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])
axis([0 10 0 10]); axis square; axis off

% Graphik
% =======
drawcsq([5 2],2,0.7*[1 1 1],'\tau',fsz+5);
drawgate(7,6,2,'OR',             'Color',col,'LineWidth',lw);
drawgate(4,7.5,2,'AND',          'Color',col,'LineWidth',lw);
drawgate(4,4.5,2,'AND',          'Color',col,'LineWidth',lw);
line([0 3],8+[0 0],              'Color',col,'LineWidth',lw)
line([0 3],5+[0 0],              'Color',col,'LineWidth',lw)
line([2 2 3],[2 7 7],            'Color',col,'LineWidth',lw)
line([2 2 10],[7 9.5 9.5],       'Color',col,'LineWidth',lw)
line([4 5 5 6],[7.5 7.5 6.5 6.5],'Color',col,'LineWidth',lw)
line([4 5 5 6],[4.5 4.5 5.5 5.5],'Color',col,'LineWidth',lw)
line([4 2 2 3],[2 2 4 4],        'Color',col,'LineWidth',lw)
line([7 8 8 6],[6 6 2 2],        'Color',col,'LineWidth',lw)
line([5 5],[1 0],                'Color',col,'LineWidth',lw)
line([2 2],[4 7],'Marker','.','LineStyle','none','MarkerSize',ms, 'Color',col)
line([3 3],[5 7],'Marker','.','LineStyle','none','MarkerSize',msn,'Color',col)

% Beschriftung
% ============
text(5.1,0,'Takt',  'FontSize',fsz,'Color',col,'HorizontalAlignment','left',  'VerticalAlignment','baseline')
text(0,8,'J',       'FontSize',fsz,'Color',col,'HorizontalAlignment','left',  'VerticalAlignment','bottom')
text(0,5,'K',       'FontSize',fsz,'Color',col,'HorizontalAlignment','left',  'VerticalAlignment','bottom')
text(10,9.5,'Q',    'FontSize',fsz,'Color',col,'HorizontalAlignment','right', 'VerticalAlignment','bottom')
text(3,2,'z',       'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom')
text(7,2,'z_{next}','FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','bottom')
