function drawmux(n)
% drawmux(n)
% Graphik eines Multiplexers mit 2^n Eingngen

% Autor:  Klaus von der Heide  e-mail:  v.d.heide@on-line.de

% Default
% =======
if nargin<1  n = 2; end

% Konstanten
% ==========
m    = 2^n;
fsiz = 50/sqrt(m);
pcol = 0.9*[1 1 1];
lcol = 0.8*[1 1 1];
inc  = 'abcdefghijklmnopqrstuvwxyzABCDEF';
while length(inc)<m  inc = [inc inc]; end
b    = '01';

% Bild und Achsen
% ===============
fh  = fullscreen('MUX','w',0,[0 max(0.2,2.5/m) 0 1]);
axes('Position',[0 0 1 1])
axis([0 22 -8 5*m]);  axis off

% Graphik
% =======
patch([8 14 14 8],(m*5-1)*[0 0 1 1],pcol);
patch([14 20 20 22 20 20 14],m*2.5-1.5+[0 0 -1 1 3 2 2],lcol)
text(20,2.5*m-0.5,'y','FontSize',fsiz,'HorizontalAlignment','right','VerticalAlignment','middle')
patch([12 12 13 11 9 10 10],[-8 -2 -2 0 -2 -2 -8],lcol)
text(11,-5,'s','FontSize',fsiz,'HorizontalAlignment','center','VerticalAlignment','middle')
for k=1:m
   patch([0 6 6 8 6 6 0],5*k-5+[1 1 0 2 4 3 3],lcol)
   text(0.5,5*k-3,inc(m-k+1),'FontSize',fsiz,'HorizontalAlignment','left','VerticalAlignment','middle')
   text(8.5,5*(m-k)+2,['s=' b(1+num2binvec(k-1,n))],'FontSize',0.7*fsiz,'HorizontalAlignment','left','VerticalAlignment','middle')
end
