function drawnorff
% drawnorff
% Schaltbild eines NOR-Basis-Flipflops

% Autor:  Klaus von der Heide,  v.d.heide@on-line.de

% Konstanten
% ==========
fsz = 18;               % FontSize
ms  = 18;               % MarkerSize
lw  = 1.2;              % LineWidth
col = 'k';              % Color

% Fenster
% =======
fh = fullscreen('NOR-FF','w',0,[2 3; 1 1]);
axes('Position',[0.05 0.05 0.9 0.9])

% Graphik
% =======
drawgate(4,2,2,'NOR','Color',col,'LineWidth',lw);
drawgate(4,7,2,'NOR','Color',col,'LineWidth',lw);
line([0 3],1.5+[0 0],'Color',col,'LineWidth',lw)
line([0 3],7.5+[0 0],'Color',col,'LineWidth',lw)
line([4 7],2+[0 0],  'Color',col,'LineWidth',lw)
line([4 7],7+[0 0],  'Color',col,'LineWidth',lw)
line([5 5 2 2 3],[2 3.5 5.5 6.5 6.5],'Color',col,'LineWidth',lw)
line([5 5 2 2 3],[7 5.5 3.5 2.5 2.5],'Color',col,'LineWidth',lw)
line([5 5],[2 7],'Marker','.','LineStyle','none','MarkerSize',ms,'Color',col)

% Beschriftung
% ============
text(1,2,  'R',  'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','middle')
text(1,8,  'S',  'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','middle')
text(6,2.5,'Q',  'FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','middle')
text(6,7.5,'Q''','FontSize',fsz,'Color',col,'HorizontalAlignment','center','VerticalAlignment','middle')
axis square; axis off
