function  s = num2babylon(z)
% s = num2babylon(z)
% Wandlung der natrlichen Zahl z in einen String mit der 
% eindimensionalen babylonischen Darstellung im Sexagesimalsystem.
% Symbol fr den Einer ist 1;  Symbol fr den Zehner ist < .
% Die Null wird nicht notiert, ist aber durch ein zustzliches blank
% rekonstruierbar, so dass die Mehrdeutigkeit des Babylonischen 
% Systems hier nicht gegeben ist.

%  Autor:  Klaus von der Heide,  v.d.heide@on-line.de

bv = num2basvec(z,60);
s = '';
for k=1:length(bv)
   nz = floor(bv(k)/10);
   ne = rem(bv(k),10);
   for i=1:nz   s = [s '<']; end
   for i=1:ne   s = [s '1']; end
   if bv(k)==0  s = [s ' ']; end
   s = [s ' '];
end

s = s(1:end-1);