function x = str2binrep(s,a)
% x = str2binrep(s,a)
% Komprimierte binre Reprsentation des Strings s im 
% Vektor x.
% a ist ein String, der die in s erlaubten Symbole in 
% der Reihenfolge enthlt, wie sie binr kodiert werden
% sollen.
% Werden an den Stellen von s verschiedene Alphabete 
% benutzt, so ist a als ein Cell Array anzugeben, das 
% pro Stelle von s den entsprechenden String der 
% erlaubten Symbole enthlt.

if nargin<2  a = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789.,?/#$'; end
if nargin<1  s = 'TEST'; end
ns = length(s);

if iscell(a)
   if length(a)~=ns  error('binrep: Die Lngen von s und a mssen gleich sein.'); end
   for k=1:ns
      na(k) = length(a{k});
      z(k) = -1;
      for j=1:na(k)
         if s(k)==a{k}(j)  z(k) = j-1; break; end
      end
      if z(k)<0  error(sprintf('binrep: Symbol s(%3d) = "%s" is nicht in a{%3d}',k,s(k),k)); end
   end
   x = num2binvec(sum(z.*cumprod([1 na(1:end-1)])),ceil(log2(prod(na))));
else
   na = length(a);
   for k=1:ns
      z(k) = -1;
      for j=1:na
         if s(k)==a(j)  z(k) = j-1; break; end
      end
      if z(k)<0  error(sprintf('binrep: Symbol s(%3d) = "%s" is nicht in a',k,s(k))); end
   end
   x = num2binvec(sum(z.*na.^(0:ns-1)),ceil(log2(na^ns)));
end