%
%
%10.1  Nicht-getaktete Schaltwerke %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-3,'Color',MSVTITLCOLOR>
%
%
%
% Bei nichtgetakteten Schaltwerken muss das Zustandsdiagramm anders interpretiert 
% werden als bei getakteten.  Im Falle des getakteten Schaltwerks gilt:
%
% Zwischen zwei Takten ndert sich der Zustand nicht. Die  \delta- und  \lambda-Schaltnetze 
% sind jedoch zeit-kontinuierlich in Aktion, so dass sich der Folgezustand  z_{next}  und 
% bei Mealy-Schaltnetzen auch die Ausgabe  y  bei nderung der Eingabe  x zwischen 
% den Takten ndern kann.  Jedoch wird nur der zur Zeit der relevanten Taktflanke 
% gerade berechnete Folgezustand  z_{next}  tatschlich als neuer Zustand  z  angenommen.
% Das Zustandsdiagramm kann also wie folgt interpretiert werden:  Der Zustand ruht 
% zwischen den Taktzeiten in einem der Knoten und springt zu den Taktzeiten zum 
% Folgezustand.
%
% Als Beispiel sei das folgende Schaltwerk betrachtet;
%
n = 4;
f = [2 1; 3 4; 3 4; 4 1];
demofsm(f)
%
% Die Interpretation beim nicht-getakteten Schaltwerk ist dagegen:  Jeder berechnete
% Folgezustand  z_{next}  wird nach der aktuellen Verzgerung der Rckkopplung auch 
% angenommen und aufgrund der darauf folgenden Neuberechnung des Folgezustand 
% mglicherweise gleich wieder verlassen.  Der Zustand wandert also permanent lngs 
% des durch die Eingabe gesteuerten Weges im Diagramm mit nicht genau bekannter 
% Geschwindigkeit.  Ein definiertes Verharren in einem Zustand gibt es nur, wenn der
% Folgezustand  z_{next}  gleich dem aktuellen  z  ist, also im Falle einer Schlinge.  
% Man nennt diesen einen stabilen Zustand.  Fr ein sinnvolles Verhalten muss ein 
% nicht-getaktetes Schaltwerk wenigstens zwei Schlingen besitzen, zwischen denen 
% durch entsprechende Eingabe gezielt gewechselt werden kann.
%
% Das selbe Schaltwerk wie oben, jedoch mit Verzgerungen anstelle der getakteten 
% Zeitglieder:
%
n = 4; 
f = [2 1; 3 4; 3 4; 4 1]; 
demofsm(f,{'A';'B';'C';'D'},1,1)
%
%% Der Input kann wie bisher bei selektiertem Zustandsdiagramm durch die Tasten 1 und 2 
%% gewhlt werden oder bei selektierter bergangstabelle durch Mausklick auf den Input 
%% in der obersten Zeile.
%
% Der stabile Zustand  D  kann nur durch genau auf die individuellen Verzgerungen 
% abgestimmte schnelle Wechsel des Inputs erreicht werden.  Da die Verzgerungen 
% nie genau bekannt sind, ist dieser Zustand in der Praxis nicht gezielt erreichbar. 
% Man muss aber bercksichtigen, dass er mglicherweise erreicht wird.
%
% Die  stabilen Zustnde sind die wesentlichen Zustnde eines nicht-getakteten Schaltwerks.
% 
% Damit die stabilen Zustnde auch in der tabellarischen Form besser zu erkennen sind, 
% benutzt man im Falle nicht-getakteter Schaltwerke die sog. {\bfFlusstafel} und {\bfAusgangstafel}  
% anstelle der bergangs- bzw. Ausgangstabellen, bei denen sowohl der Zustand wie auch 
% der Input als Eingangsvariablen der Schaltfunktionen im linken Teil der Tabelle und 
% die Funktionswerte jeweils als eine Spalte rechts dargestellt werden.  Wir haben der 
% bersichtlickeit halber auch bei den getakteten Schaltwerken schon die Flusstafel gezeigt.
% Im Falle von nicht-getakteten Schaltwerken werden die stabilen Zustnde in der Flusstafel 
% durch Einkreisen besonders hervorgehoben.  Alle anderen Zustnde sind nur kurzzeitige 
% Durchgangsstationen.
%
% Das Verhalten eines nicht-getakteten Schaltwerks lsst sich nur dann eindeutig verfolgen, 
% wenn man die Eingabe in folgender Weise einschrnkt:
%
% (1)  Der Eingang  x  ndert sich nur, wenn das Schaltwerk  sich in einem stabilen 
%       Zustand befindet.
%
% (2)  Der Eingang  x  ndert sich nur einschrittig.
%
% Unter dieser Voraussetzung kann im vorigen Beispiel der Zustand D nicht erreicht werden.
%
% Durch die Bedingung (2) werden Funktionshasards vermieden, die bei gleichzeitiger 
% nderung mehrerer Inputwerte entstehen.  Es knnen sich aber auch durch die nderung 
% einer einzigen Inputvariablen mehrere Bits des Zustands ndern.  Diese Bits fhren 
% durch die Zeitglieder des Schaltwerkmodells zum Eingang des  \delta-Schaltnetzes 
% einen {\bfWettlauf} durch.  Der nachfolgende Zustand hngt dann vom Ausgang des 
% Wettlaufs ab.  Wenn die stabilen Zustnde, die durch den Wettlauf direkt oder als 
% Folge erreicht werden, unterschiedlich sind, ist das Verhalten des Schaltwerks 
% nicht beherrschbar.  Man nennt den Wettlauf dann kritisch, im anderen Fall unkritisch.
%
% Eine Mglichkeit Wettlufe zu vermeiden ist die Benutzung einer einschrittigen 
% Codierung der Zustnde.  Damit ist hier gemeint, dass smtliche Kanten des 
% Zustandsdiagramms zwischen Zustnden verlaufen, deren Codierung sich um hchstens 
% ein Bit unterscheidet.  Das ist aber viel schwieriger als nur die Einfhrung einer 
% neuen Codierung, da ja die Schaltnetze selbst wieder von der Codierung abhngen.
%
% Einen weiteren Fall, den man vermeiden sollte, zeigt das folgende Schaltwerk.  Hier 
% kann der Zustand  Z1  nicht unter Einhaltung der oben genannten Voraussetzungen 
% verlassen werden.  Dies bedeutet, dass ein so realisiertes Schaltwerk tatschlich 
% im Zustand Z1 hngen bleibt oder diesen erst nach vielen Versuchen verlsst.  Das 
% Verhalten mehrerer vllig gleich realisierter Schaltwerke kann dabei unterschiedlich 
% sein, da es stark von den individuellen Verzgerungen abhngt.
%
demofsm([1 2; 4 3; 3 2; 1 4],{'RR';'Go';'Z1';'Z2'},3,1)
%