%
%
%10.3  Entwurf eines rckflankengesteuerten D-Flipflops %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-17,'Color',MSVTITLCOLOR>
%
%
%
% Es ist nicht das Anliegen dieses Skriptes, eine Anleitung zu liefern fr den Entwurf 
% nichtgetakteter Schaltwerke.  Jedoch soll hier kurz der Entwurfsvorgang nachvollzogen 
% werden.  Der Entwurf ist ausfhrlicher beschrieben in Lagemann: Rechnerstrukturen.
% Diesem Buch ist auch das folgende Beispiel entnommen.
%
% Ausgangspunkt des Entwurfs ist zumeist eine nicht formale Beschreibung des Verhaltens 
% fr das gewnschte Schaltwerk anhand von typischen Signalverlufen.  Fr ein rck-
% flankengesteuertes Flipflop knnte dies z.B. sein:
%
d = [0 0 0 1 1 1 1 1 0 0 0 0 1 1 1 0 0];
c = [0 1 0 0 1 0 1 0 0 1 0 1 1 0 1 1 0];
q = [0 0 0 0 0 1 1 1 1 1 0 0 0 1 1 1 0];
titel = 'Verhalten eines rckflankengesteuerten Flipflops';
drawbinsigs(nfach([d;c;q],10),titel,{'D';'Takt';'Ausgang'})
%
%
%% Dieser Abschnitt wird noch eingefgt!
%% Nach mehreren Schritten gelangt man zu einem reduzierten Zustandsdiagramm.  
%% Nun wird eine passende Codierung der Zustnde gewhlt.  Dann lassen sich 
%% die schaltalgebraischen Ausdrcke der berfhrungsfunktion ermitteln. 
%% Mithilfe des KV-Diagramms kommt man schliesslich zu einer Realisierung:
%
drawetdffm
%
%% Der Strukturhasard sollte noch beseitigt werden!
%
delta = {'~(~(z1&C)&~(z2&~C))';'~(~(D&C)&~(z2&~C))'};
incod = {'D=0; C=0;'; 'D=0; C=1;'; 'D=1; C=1;'; 'D=1; C=0;'};
utab  = binexp2flusstafel(delta,incod)
zcod = {'00';'01';'10';'11'};
xcod = {'00';'01';'11';'10'};
xnam = 'D,C';
demofsm(utab,zcod,2,1,xcod,xnam)
%
