%
%
%10.5  Voreinstell- und Haltezeit %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Wir haben fr nichtgetaktete Schaltwerke generell gefordert:
%
% (1)  Der Eingang  {\fontname{Courier}x}  ndert sich nur, wenn das Schaltwerk  sich in einem stabilen 
%       Zustand befindet.
%
% (2)  Der Eingang  {\fontname{Courier}x}  ndert sich nur einschrittig.
%
% Wir wollen in diesem Abschnitt die Konsequenzen dieser Einschrnkung fr Flipflops 
% behandeln.  Die Einschrnkung bedeutet, dass sich Dateneingang und Takt nicht 
% gleichzeitig ndern drfen.  Mehr noch: wenn sich der Dateneingang gendert hat,
% darf die nchste Taktflanke erst auftreten, wenn das Flipflop einen stabilen Zustand 
% erreicht hat.  Entsprechend gilt: wenn eine Taktflanke aufgetreten ist, darf sich der 
% Dateneingang erst wieder ndern, wenn das Flipfop einen stabilen Zustand erreicht hat.  
% Demnach darf sich das Datensignal in einem Zeitintervall  {\fontname{Courier}[T - S , T + H]}  um den 
% Zeitpunkt  {\fontname{Courier}T}  der Taktflanke nicht ndern.  Wir nennen  {\fontname{Courier}S}  die Voreinstellzeit (setup time) 
% und  {\fontname{Courier}H}  die Haltezeit (hold time).  {\fontname{Courier}S}  und  {\fontname{Courier}H}  sind Worst-Case-Werte fr die entsprechenden 
% Zeiten zum Erreichen der stabilen Zustnde.  Im Gegensatz zu unserer Entwurfsforderung, 
% unabhngig von allen individuellen Verzgerungen zu sein, mssen wir uns hier darauf 
% verlassen, dass hergestellte Flipflops die fr den jeweiligen Typ angegebenen Zeiten  
% {\fontname{Courier}S}  und  {\fontname{Courier}H}  nicht berschreiten.
%
% Nachfolgend geben wir einige Beispiele fr das Verhalten von Flipflops bei Dateninput-
% nderung innerhalb des verbotenen Intervalls.  Man beachte aber, dass dies das Verhalten 
% eines Modells ist.  Das tatschliche Verhalten ist abhngig von der Technologie.
%
%
% \bfTaktpegel-gesteuertes Earle-Latch (Kap. 10.2)
%
D = [0 0 1 0 0 1 0 0 0 0];         % Dateninput
C = [0 1 1 0 0 0 1 0 0 0];         % Taktinput
insigs = nfach([D;C],50);          % Inputmatrix fr drawswsigs
dearle = {'(~C&z1)|(C&D)|(D&z1)'}; % berfhrungsfunktion Earle-Latch
dly = {[1 2 1 1]};                 % Verzgerungen der Verknpfungen
drawswsigs(dearle,{'D';'C'},dly,insigs);
%
%
% \bfTaktpegel-gesteuertes D-Latch (Kap. 10.4)
%
D = [0 0 1 0 1 0 1 1 1 0 1 0 0 0 0];           % Dateninput
C = [0 1 1 0 0 1 0 0 0 0 0 0 0 1 0];           % Taktinput
insigs = [nfach(D,10);delay(nfach(C,10),1)];   % Inputmatrix fr drawswsigs
dlatch = {'~(z2&~(C&D))';'~(z1&~(C&~(C&D)))'}; % berfhrungsfunktion D-Latch
dly = {[1 1]; [1 1 1]};                        % Verzgerungen der Verknpfungen
drawswsigs(dlatch,{'D';'C'},dly,insigs);
%
%
% \bfRckflankengesteuertes D-Flipflop (Kap. 10.4)
%
D = [0 0 0 1 1 0 0 1 1 1 1 0 0 0 1 1 1 1 1 1 1]; % Dateninput
C = [1 0 0 1 0 0 1 0 0 0 1 0 0 0 0 1 1 1 0 0 0]; % Taktinput
insigs = [nfach(D,10); delay(nfach(C,10),0)];    % Inputmatrix fr drawswsigs
dly = {[1 1]; [1 1 1]; 1; 1};                    % Verzgerungen der Verknpfungen
delta = {'~(z2|C|~(z1|D))';'~(C|~(z2|~(z1|D)))';'~(z2|z4)';'~(z1|z3)'};
drawswsigs(delta,{'D';'C'},dly,insigs);
%
%% Entsprechende Beispiele fr die anderen Flipfloptypen kann der Leser durch eigene Versuche finden.
%