%
%
%10.6  Spezielle Flipflops %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Getaktete Zeitglieder in getakteten Schaltwerken sollten flankengesteuert sein,
% weil sie bei Pegelsteuerung nur eine Verzgerung darstellen, solange der Takt 
% {\fontname{Courier}C = 1}  ist, wodurch das getaktete Schaltwerk fr die Taktphasen zu einen nicht-
% getakteten Schaltwerk wrde.  Andererseits gibt es auch gute Grnde fr die 
% Benutzung von Flipflops, die ein der Flankensteuerung entsprechendes Verhalten 
% haben, sich aber auch umschalten lassen in eine Verzgerung.  Eine hufige 
% Anwendung fr solche Flipflops findet sich an den Ein- und Ausgngen von 
% Schaltnetzen in komplexen Systemen, die im Normalbetrieb als Fliessbnder 
% getaktet arbeiten.  Beim Test der Schaltnetze stren die Flipflops aber, weil 
% sie das Zeitverhalten des Schaltnetzes verbergen.  Zum Test schaltet man daher 
% die Flipflops transparent.  Sehr hufig wird eine weitere Funktion hinzugefgt,
% nmlich die Mglichkeit, alle oder ausgewhlte Flipflops als Schieberegister 
% zu schalten.  Diese letzte Mglichkeit wollen wir erst im Kapitel 12 behandeln.
%
% Eine technisch gute Methode, Transparenz mit Zweiflankensteuerung zu verbinden 
% ist die Serienschaltung zweier pegelgesteuerter D-Flipflops, die mit zwei getrennten 
% Takten versorgt werden:
% 
drawtwolatch
%
% Die fallende Flanke des ersten Taktes bernimmt das Eingangsdatum in das erste
% Latch, die steigende Flanke des zweiten Flipflops bernimmt den Inhalt des ersten 
% Flipflops in das zweite und gibt damit diesen Wert auf  {\fontname{Courier}Q}  aus.
%
% Whrend  {\fontname{Courier}C_1 = 1}  ({\fontname{Courier}C_2 = 1})  ist das erste (zweite) Latch transparent.  Im Normal-
% betrieb drfen also  {\fontname{Courier}C_1}  und  {\fontname{Courier}C_2}  nicht beide zugleich  {\fontname{Courier}1}  sein.  Mit  {\fontname{Courier}C_1 = C_2 = 1}  
% kann man jedoch gezielt beide Flipflops transparent schalten.
%
% Das Zustandsdiagramm dieser Anordnung hat 4 Zustnde.
%
utab = [1 1 1 1 1 1 2 2; 2 3 1 4 2 3 2 3; 3 3 4 4 3 3 3 3; 4 1 4 1 4 1 3 3];
xnam = {'000';'001';'010';'011';'100';'101';'110';'111'};
znam = {'00';'10';'11';'01'};
demofsm(utab,znam,1,1,xnam,'D,C_1,C_2')
%% Hier sollte man z.B. durch Mausklicke in die Input-Indexzeile der Flusstafel 
%% typische Sequenzen durchspielen, z.B. Speichern  1 und  0 und Transparenz durch:
%% 000, 100, 110, 100, 101, 100, 000, 010, 000, 001, 000, 011, 111, 011, ...
%
% Das folgende Signalspiel zeigt der Reihe nach von links nach rechts das Speichern 
% einer  {\fontname{Courier}0} , einer  {\fontname{Courier}1} , einer  {\fontname{Courier}0}  und schliesslich das Schalten beider Flipflops auf 
% Transparenz:
%
D  = [0 0 0 0 0 0 1 1 1 0 1 0 1 0 0 0 0 0 0 1 0 1 0]; % Dateninput
C1 = [0 0 1 0 0 0 0 1 0 0 0 0 0 0 1 0 0 0 1 1 1 1 1]; % Taktinput 1
C2 = [0 0 0 0 1 0 0 0 0 1 1 0 0 0 0 0 1 0 1 1 1 1 1]; % Taktinput 2
xnam = {'D';'C1';'C2'};
insigs = nfach([D; C1; C2],20);               % Inputmatrix fr drawswsigs
delta = {'(~C1&z1)|(C1&D)|(D&z1)';'(~C2&z2)|(C2&z1)|(z1&z2)'}; % berfhrungsfunktion
dly = {ceil(3*rand(1,4)); ceil(3*rand(1,4))}; % zufllige Verzgerungen aller Verknpfungen
drawswsigs(delta,xnam,dly,insigs); % Simulation
%
% Das folgende Skript tut das vorige zwanzig mal mit zuflligen Verzgerungen und und 
% zeigt anschliessend das Ergebnis in schneller Folge:
%
%% Das rechnet eine Weile!  Die Animation wird durch Mausklick in eines der Bilder gestoppt.
n = 20;
for k=1:n dly = {ceil(3*rand(1,4)); ceil(3*rand(1,4))}; h(k)=drawswsigs(delta,xnam,dly,insigs); end
set(h,'UserData',1,'WindowButtonDownFcn','set(gcf,''UserData'',0)')
s = 1;
while s for k=1:n figure(h(1+mod(k,n))); s=get(gcf,'UserData'); if ~s break; end; pause(0.001); end; end
%