%
%
%12.2  Register  %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Ein Register ist ein Bndel von  {\fontname{Courier}n}  gleichen Flipflops, die alle mit dem selben Takt 
% arbeiten und bei denen sowohl der Dateneingang wie der Datenausgang als Bndel 
% von je  {\fontname{Courier}n}  Bits behandelt wird:
%
drawdreg
%
% Das Verhalten des Registers entspricht dem des benutzten Flipfloptyps.  Das Zeitverhalten 
% wird auf der R-T-Ebene fr alle Flipflops als gleich angenommen.  Das Register hat also 
% eine Voreinstell- und eine Haltezeit wie die seiner Komponenten.
%
% Neben den einfachen Datenregistern, die als Zwischenspeicher von n-Bit-Wrtern dienen 
% gibt es die {\bfSchieberegister}.  Ein n-Bit-Rechts-Schieberegister ist ein spezielles 
% getaktetes Schaltwerk, fr dessen Zustandsbits gilt:
%
% z_{1,next} = x                       %<'FontName',MSVFORMFONT>
% z_{i,next} = z_{i-1}   (i=2,...,n)   %<'FontName',MSVFORMFONT>
%
% Die Ausgabe kann sein:
%
% {\fontname{Courier}y_i = z_i  \forall i}    (paralleler Ausgang von n Bits)
%
% oder nur  {\fontname{Courier}y = z_n}  (serieller Ausgang, 1 Bit)
%
% Die Realisierung dieses Schieberegisters ist sehr einfach.  Es ist nur jeweils der 
% Dateneingang des i-ten Flipflops mit dem Ausgang des (i-1)-ten Flipflops zu verbinden.
% Das Zustandsdiagramm dieses fast trivialen Schaltwerks ist berraschend komplex, wie 
% das folgende Beispiel des 4-Bit-Schieberegisters zeigt:
%
n = 4;                                % Anzahl der Bits
delta = {'x'};
for k=1:n-1  delta = cat(2,delta,{['z' num2str(k)]}); end % Ausdruck fr zi-next
invar = {'x=0;';'x=1;'};              % Inputmglichkeiten
xcod  = {'0';'1'};                    % Inputcodierung
ft = binexp2flusstafel(delta,invar);  % Flusstafel
for j=1:2^n  zcod{j} = num2basstr(j-1,2,n); end
demofsm(ft,zcod,1,0,xcod)
%% Fr anderes n MATLAB-Code mit Taste c in den Editor holen, n ndern, dann Men run whlen.
%
% Durch Umnumerierung der Flipflops kann man das Schieberegister zu einem Rechts-
% Schieberregister machen.  
%
% Deutlich aufwndiger ist ein Schieberegister, welches gesteuert duch ein Inputbit  {\fontname{Courier}S} 
% in beide Richtungen schieben kann.  blich ist in diesem Fall das parallele Laden 
% aller Flipflops ber einen entsprechend breiten Dateneingang {\fontname{Courier}D}.  Geladen wird, 
% wenn das Inputbit  {\fontname{Courier}L}  gesetzt ist.  Es muss vor jedem  {\fontname{Courier}D}-Eingang der Flipflops ein 
% 3-zu-1-Multiplexer sein, mit dem das aktuell zu speichende Bit gewhlt werden kann:
%
% z_{i,next} = L'\cap(s'\capz_{i-1} \cup s\capz_{i+1}) | L\capD_i   (i=1,...,n)   %<'FontName',MSVFORMFONT>
%
% Wir sehen uns solch ein Links-Rechts-Schieberegister mit parallelem Laden wieder 
% am einfachen Fall von  {\fontname{Courier}n = 4}  an.  Die Flusstafel wrde aber mit den 6 Inputbits 
% {\fontname{Courier}S, L, D_1, D_2, D_3, D_4}  sehr unbersichtlich werden.  Wir verzichten deshalb 
% in der Graphik auf die D-Bits und laden mit  {\fontname{Courier}L = 1}  zufllige Bitmuster:
%
n = 4;
delta{1} = '(~L&((~S&0)  | (S&z2))) | (L&randb)';      % Ausdruck fr z1-next
for k=2:n-1 delta{k} = ['(~L&((~S&z' num2str(k-1) ') | (S&z' num2str(k+1) '))) | (L&randb)']; end % Ausdruck fr z1-next
delta{n} = ['(~L&((~S&z' num2str(n-1) ') | (S&0) )) | (L&randb)']; % Ausdruck fr zn-next
invar = {'L=0;S=0;';'L=1;S=0;';'L=1;S=1;';'L=0;S=1;'}; % Inputmglichkeiten
xcod  = {'00';'10';'11';'01'};                         % Inputcodierung LS
ft = binexp2flusstafel(delta,invar);                   % Flusstafel
for j=1:2^n  zcod{j} = num2basstr(j-1,2,n); end
demofsm(ft,zcod,1,0,xcod)
%% Fr anderes n MATLAB-Code mit Taste c in den Editor holen, n ndern, dann Men run whlen.
%
% Man kann die vierte Codierung der Eingabe  {\fontname{Courier}L=1; S=1}  verwenden, um das Schieben 
% und das Laden gleichzeitig zu unterbinden.  Dadurch erhlt man an jedem Zustand eine 
% Schlinge (hier ist n=4 fest vorgegeben):
%
delta{1} = '(~L&((~S&0)  | (S&z2))) | (L&~S&randb) | (L&S&z1)'; % Ausdruck fr z1-next
delta{2} = '(~L&((~S&z1) | (S&z3))) | (L&~S&randb) | (L&S&z2)'; % Ausdruck fr z1-next
delta{3} = '(~L&((~S&z2) | (S&z4))) | (L&~S&randb) | (L&S&z3)'; % Ausdruck fr z1-next
delta{4} = '(~L&((~S&z3) | (S&0) )) | (L&~S&randb) | (L&S&z4)'; % Ausdruck fr z1-next
invar = {'L=0;S=0;';'L=1;S=0;';'L=1;S=1;';'L=0;S=1;'}; % Inputmglichkeiten
xcod  = {'00';'10';'11';'01'};
ft = binexp2flusstafel(delta,invar);   % Flusstafel
for j=1:16  zcod{j} = num2basstr(j-1,2,4); end
demofsm(ft,zcod,1,0,xcod)
%
% Schieberegister sind wichtig bei der Realisierung der Multiplikation.  Ein Schritt 
% nach links entspricht der Multiplikation mit 2, ein Schritt nach rechts der Division 
% durch 2.
%
%
% Unter einer {\bfRegisterbank} versteht man eine meist kleine Zahl (4 ... 32) von 
% gleichen Datenregistern, die ber einen gemeinsamen Zugriffskanal verfgen.
%
