%
%
%1.2  Geschichte der Informatik%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Wissenschaft hat man auf allen Gebieten betrieben, bevor die Gebiete sich im 
% einzelnen herauskristallisiert haben und einen eigenen Namen bekamen.
%
% Die Definition der  {\bfInformatik}  aus dem vorigen Kapitel setzt den programmierbaren 
% Rechner nicht voraus.  berall, wo gemessen und Gemessenes verwaltet wurde, war 
% Informatik.
%
% Die Lnge des Jahres von  {\fontname{Courier}365 ^1/_4}  Tagen war immerhin bekannt vor  {\fontname{Courier}6230}  Jahren.  
% Fr solch eine Messung muss es nicht nur Messverfahren geben, sondern auch 
% Mglichkeiten der sprachlichen Bezeichnung und der schriftlichen Fixierung von 
% Zahlen der Grssenordnung  {\fontname{Courier}10000} .
%
% Beispiele fr alte Schriften von Zahlen geben die Seiten 1, 2, 8, 9 der Prsentation T1\_1. 
% Zhlsymbole wie auf Seite 1 der Prsentation T1\_1 wurden lange vor Erfindung der Schrift 
% benutzt.  Die versiegelten Tonkugeln enthielten stellvertretend fr irgendetwas 
% die Zhlsymbole.  Auf diese Weise konnte man vor der Einfhrung der Schrift 
% quantitativ festgelegte Vertrge abschliessen.
%
% Nippur in Mesopotamien, wo man ca.  {\fontname{Courier}50000}  Tontafeln fand, wurde im Jahre  {\fontname{Courier}-1955} von 
% den Elamiten zerstrt.  Die Tafeln sind also durchweg lter.  Dies ist etwa die Zeit, 
% als die Abstraktion zur Zahl an sich vollzogen wurde.  Sehr lange vorher hat man 
% schon genau Buch gefhrt, jedoch bei Zahlenangaben grundstzlich das Gezhlte mit 
% benannt.  Die meisten Zahlennotationen galten sogar jeweils nur fr Getreide bzw. 
% fr Grundstckgrssen, fr Stck Vieh usw..
%
% Viel jnger, nmlich  {\fontname{Courier}3400}  Jahre alt Wandmalereien aus Abd-el-Qurna, die sehr
% schn das Messen und Registrieren zeigen.  Das Messen ist der Ursprung der Zahl.  
% Die Zahl ist die Abstraktion vom Gemessenen und beruht auf dem Distributivgesetz fr 
% Anzahlen von Dingen, die man abzhlen kann:
%
distributivzahl
%
% Es gilt also
%
%          a X   +   b X   =   (a + b) X      %<'FontName',MSVFORMFONT>
%
% wo  {\fontname{Courier}a}  und  {\fontname{Courier}b}  und  {\fontname{Courier}a + b}  Anzahlen der zu zhlenden Einheit  {\fontname{Courier}X}  sind.
% X steht z.B. fr pfel, Euro etc.
%
% Die alten Zahlenschriften sind nicht gut geeignet fr Algorithmen zur Addition und 
% Multiplikation.  Z.B. wre die Addition einer Mehrwertsteuer von  {\fontname{Courier}16%}  sehr 
% kompliziert.  Dieses Problem wurde damals durch Tabellen gelst, die ein erstes 
% Beispiel fr Datenstrukturen liefern.
%
% Auch kannte man das Problem von Diskrepanzen zwischen karteimssig gefhrten 
% und tatschlich vorhandenen Bestnden und fand Lagermethoden, die einerseits das 
% Entwenden erschwerten und andererseits auch die Ermittlung von Diskrepanzen 
% ermglichten.  Das Bild 10 der Prsentation T1\_1 gibt ein Beispiel.
%
%% Wieviele Kugeln mag der grosse Haufen rechts im Vordergrund enthalten ?
%% ca.:      100      400      1600      6400    ??
%
% Auch in Nippur fand man Tontafeln mit Tabellen der Dreiecks und Pyramidenzahlen. 
% Sei die Breite (und damit auch die Giebelseite) der Pyramide  {\fontname{Courier}n}  und die Firstlnge  {\fontname{Courier}m} , 
% dann ist der Pyramideninhalt
%
%         n        n                                             %<'FontName',MSVFORMFONT>
% (m - 1)_{\fontsize{26}\Sigma} i  +  _{\fontsize{26}\Sigma} i^2 %<'FontName',MSVFORMFONT>
%        i=1      i=1                                            %<'FontName',MSVFORMFONT>
%
% Fr die Summen gibt es einfache Ausdrcke:
%
n = 23     % Kantenlnge fr das Schtzbeispiel
m = 8      % Firstlnge fr das Schtzbeispiel
a = (m-1)*sum(1:n) + sum((1:n).^2)   % Summen ausrechnen
b = n*(n+1)*((2*n+1)/3 + m - 1)/2    % effizienterer Ausdruck
%
% Das Resultat erscheint im Kommandofenster.
%
% Das Sexagesimalsystem der Sumerer  -  jedoch nicht seine Schreibweise  -  hat sich 
% bis heute ber die Griechen und Rmer in der Zeit- und Winkeleinteilung erhalten.
%
% Ein technisches Hilfsmittel fr die algorithmische Durchfhrung arithmetischer 
% Operationen ist der Abacus.  Im folgenden Bild ist die Addition mit einem 
% japanischen gezeigt.  Der Abacus ist ein Akkumulator.  Er ist Stellen-orientiert
% und kennt die Null.  Dies ist den ersten Benutzern wohl nicht bewusst gewesen. 
%
%% Einen Abacus auf dem OH-Projektor mit einer mehrstelligen Addition vorfhren.
%
%% Es geht weiter in der Prsentation T1\_1 mit einer Reihe von Bildern zur neueren 
%% Geschichte: Leibnitz, P.M.Hahn, Babbage, Zuse etc.
%