%
%
%2.  Reprsentation von Zahlen%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Zahlen wurden in der frhen menschlichen Geschichte zunchst mithilfe von Zhlsymbolen 
% dargestellt.  Bei Bargeld ist dies bis heute blich.  Die Addition wird einfach durch 
% das Zusammenwerfen realisiert.  Wenn die Summe zu unhandlich ist, kann irgendwann 
% durch einfaches Ersetzen (bei Geld das sog. Wechseln) einer festgelegten Anzahl 
% niederwertiger Zhlsymbole durch ein Zhlsymbol hheren Wertes eine handlichere 
% Reprsentation erreicht werden.
%
%% Die Bildbeispiele sind in der Prsentation T1\_2 ! 
%
% Um das Jahr  {\fontname{Courier}-2000}  herum, heute also vor etwa  {\fontname{Courier}4000} Jahren, wurde die Stellen-
% orientierte Zahlendarstellung in Babylon erfunden.  Die Basis der Darstellung war 
% nicht wie heute blich  {\fontname{Courier}10} , sondern  {\fontname{Courier}60} .  Man nennt es das Sexagesimalsystem.  
% Es hat sich in der Zeit- und der Winkeleinteilung erhalten.  Die Notation der  {\fontname{Courier}60}  Ziffern 
% erfolgt durch die schon vor der Erfindung des Systems benutzten Zhlsymbole fr Einer 
% und Zehner.  Wir benutzen hier anstelle der platzsparenden Stifteindrcke im Ton die 
% Symbole  {\fontname{Courier}1}  und  {\fontname{Courier}<} .  Die Benutzung von Zhlsymbolen hat die Folge, dass die Ziffer  {\fontname{Courier}0}  
% kein Zhlsymbol erhlt, also nicht geschrieben wird.  Tatschlich haben die Babylonier 
% nur selten Fehler gemacht, obwohl die Schreibweise mehrdeutig war.  Ein Beispiel fr 
% solch einen Fehler wird gleich behandelt werden.
%
% Die Darstellung nicht negativer ganzer Zahlen  {\fontname{Courier}x}  beruht auf deren eindeutiger Zerlegung
% nach
%    n-1                               %<'FontName',MSVFORMFONT>
% x = _{\fontsize{26}\Sigma} z_i b^i   %<'FontName',MSVFORMFONT>
%    i=0                               %<'FontName',MSVFORMFONT>
%
% wo fr alle sog. Ziffern gilt:  {\fontname{Courier}0 \leq z_i < b} .
%
% Im Dezimalsystem mit  {\fontname{Courier}b = 10}  bedeutet die Schreibweise  {\fontname{Courier}743}  die Zahl mit dem Wert
%
% x = 3*10^0 + 4*10^1 + 7*10^2 .       %<'FontName',MSVFORMFONT>
%
% Entsprechend bedeutete die Schreibweise  {\fontname{Courier}<11 <<111}  in Babylon die Zahl mit dem Wert
% 
% x = 23*60^0 + 12*60^1 = 743 .        %<'FontName',MSVFORMFONT>
%
% Es knnte aber auch z.B.  {\fontname{Courier}23*60^0 + 12*60^2}  gemeint sein, weil  {\fontname{Courier}0*60^1} nicht notiert 
% wurde.  Ein Beispiel fr solch einen (seltenen) Fehler zeigt die in der Prsentation 
% abgebildete altbabylonische Schultafel, auf der die Potenzen von  {\fontname{Courier}100}  im Sexagesimalsystem 
% bis  {\fontname{Courier}100^{10}}  berechnet werden.
%
% Wie haben wir es doch einfach:
%
zahl = '1 <<<<';   % Zahl deren Potenzen zu berechnen sind
n    = 10;         % hchste Potenz
clear p
p{1} = zahl; 
for k=1:n-1  p{k+1} = multbabylon(p{k},zahl); end;
s = '';
for k=1:length(p)  s = sprintf('%s%2d    %s\n\n',s,k,p{k}); end;
s
%
%% Die Liste der Potenzen erscheint im Kommandofenster.
%
% Die Ziffer  {\fontname{Courier}0}  ist hier im Gegensatz zur babylonischen Schreibweise zu erkennen an der 
% grsseren Lcke in der Zeile 6.  Unserem Mathematiker aus Babylon wollen wir zugute 
% halten, (1) dass die Zahlen, mit denen er hantierte z.T. deutlich grsser sind als die 
% Anzahl der Sekunden, die seit dem Urknall bis heute abgelaufen sind und (2) dass
% auf der Rckseite der Tafel eine entsprechende Tabelle der Potenzen von  5  fehlerfrei 
% ausgerechnet ist.  Wir knnen das hier nachrechnen:
%
%% Obigen MATLAB-Block selektieren, dann  "c"  tippen.  Es erscheint der MATLAB-Block im
%% Editor.  Dort fr zahl in babylonisch anstelle der  '1 <<<<'  die zu potenzierende Zahl 
%% einsetzen, z.B.  '11'  oder  '11111'  fr  2  bzw.  5 , und dann unter Tools 'run'  klicken.
%
% Fr den Interessierten gibt es hier zwei Funktionen zur (linearen textuellen) Darstellung
% der babylonischen Schreibweise von Zahlen und ihrer Rckwandlung sowie fr die 
% Addition und Multiplikation beliebig grosser Zahlen:
%
s = num2babylon(743)
%
z = babylon2num(s)
%
s = addbabylon('<< <1','111')
%
p = multbabylon('111 <<<1111 << 1111 <<<<<111 <<111','<<<11111 <<111 <1')
%
%% Resultate im Kommandofenster!  Bei dieser Gelegenheit knnen Sie auch die Tabelle der 
%% Potenzen von 100 z.B. bis n = 30 ausgeben lassen und nachrechnen, ob es stimmt. 
%
% Auch wenn heute das Sexagesimalsystem schwerfllig erscheint, so war es fr die 
% damaligen Verhltnisse recht gut geeignet.  Insbesondere die in einer durch und 
% durch verwalteten Gesellschaft wichtige Operation der Teilung durch 2, 3, 4, 5, 6,
% 10, 12, 15, 20, 30  ist in diesem System zu realisieren durch eine einfache 
% Multiplikation mit  30, 20, 15, 12, 10, 6, 5, 4, 3, 2  und eine Stellenverschiebung.
% Vermutlich war genau dies der Grund fr die Einfhrung des Systems.  Dann muss 
% man die Erfindung als genial bezeichnen, denn es gibt kein besseres System, in dem 
% Arithmetik mithilfe handhabbarer Tabellen so gut durchgefhrt werden konnte.
%
%
% Die Reprsentation von nicht negativen ganzen Zahlen und Brchen in Stellensystemen 
% zur Basis  {\fontname{Courier}b}  wird im folgenden mit interaktiven Graphiken erlutert.
%
% Die MATLAB-Funktion  {\fontname{Courier}stellen2stellen(q,z)}  stellt den Algorithmus zur 
% Umrechnung zwischen Stellensystemen dar.  Die Parameter bedeuten:
% q  :  Basis des Stellensystems
% z  :  darzustellende Zahl
% r  :  String mit dem Resultat
%% q und z knnen interaktiv gendert werden.  Eingaben immer mit der Eingabetaste abschliessen ! 
%% Der Algorithmus wird durch Klicken in das grne Taktfeld schrittweise ausgefhrt.
%
stellen2stellen(16,12345678)
%
% Alternativ kann die Funktion  {\fontname{Courier}demostellen}  in den Editor geholt werden.  Mit einem 
% {\fontname{Courier}break}  am Anfang kann man das Geschehen direkt verfolgen und die momentanen 
% Werte der Variablen durch Schieben des Cursors auf den Namen der Variablen im 
% Programm erfragen.  Der Algorithmus wird schrittweise ausgefhrt durch Klick 
% auf  {\fontname{Courier}'single step'}  in der Menleiste. 
%% Im Unterricht empfiehlt es sich, im Editor unter Tools / Font die Fontgrsse 24 fett zu whlen.
%% Die schrittweise Ausfhrung muss manuell beendet werden durch Klicken in der Menleiste 
%% des Editors auf den senkrechten geraden Pfeil fr "continue".   Evtl. geffnete Editorfenster 
%% sollten dann manuell geschlossen werden.
%
edit demostellen               % Programm in Editor
dbstop in 'demostellen' at 2   % break in Zeile 2
s = demostellen(2,25)          % Programmaufruf
binmatout(reverse(s))          % Ausgabe des Resultats
%
% Die Umwandlung echter Brche in die Stellendarstellung erfolgt mit einem gering-
% fgig genderten Algorithmus.  Die Numerierung der Stellen erfolgt dabei vom 
% Komma ausgehend nach rechts:
%
edit demoechtbruch             % Programm in Editor
dbstop in 'demoechtbruch' at 2 % break in Zeile 2 
q = 10;                        % Basis = 10
s = demoechtbruch(q,0.12345,3) % Programmaufruf
['0.'  num2basstr2(s,q)']      % Ausgabe des Resultats
%
% Durch Kombination beider Verfahren knnen beliebige Zahlen umgewandelt werden. 
% Dazu wird die Zahl aufgeteilt in den ganzzahligen Teil und einen echten Bruch:
% 
edit demobruch                 % Programm in Editor
dbstop in 'demobruch' at 3     % break in Zeile 3 
q = 10;                        % Basis = 10
s = demobruch(q,543.12345,3)   % Programmaufruf
%
%
%\bfArithmetik
%
%\bfRealisierung der Arithmetik
%
% (a) Addierer
%
% Gegeben seien zwei Zahlen in Stellendarstellung zur Basis  b :
%
%    n-1              n-1                                                     %<'FontName',MSVFORMFONT>
% x = _{\fontsize{26}\Sigma} x_i b^i ;   y = _{\fontsize{26}\Sigma} y_i b^i   %<'FontName',MSVFORMFONT>
%    i=0              i=0                                                     %<'FontName',MSVFORMFONT>
%
% Ihre Summe ist
%
%         n-1          n-1           n-1                                      %<'FontName',MSVFORMFONT>
% x + y = _{\fontsize{26}\Sigma} x_i b^i  +  _{\fontsize{26}\Sigma} y_i b^i x  = _{\fontsize{26}\Sigma} (x_i + y_i) b^i  %<'FontName',MSVFORMFONT>
%         i=0          i=0           i=0                                      %<'FontName',MSVFORMFONT>
%
% Wegen  {\fontname{Courier}0 \leq x_i < b}  und  {\fontname{Courier}0 \leq y_i < b}  gilt  {\fontname{Courier}0 \leq (x_i + y_i) \leq  2b - 1} .
% {\fontname{Courier}x_i + y_i}  kann damit grsser als  {\fontname{Courier}b - 1}  sein, es ist sind also nicht eine Ziffern des 
% Resultats.  Um die Ziffern des Resultats zu ermitteln, ist obiger Ausdruck fr die 
% Summe in den Algorithmus zur Berechnung der Stellendarstellung (siehe  {\fontname{Courier}demostellen} ) 
% einzusetzen.  Man erhlt folgenden Algorithmus fr die Addition:
%
% c_0 = 0                                   %<'FontName',MSVFORMFONT>
% for i = 1 to n                            %<'FontName',MSVFORMFONT>
%     z_i  = (x_i + y_i + c_i) mod b        %<'FontName',MSVFORMFONT>
%    c_{i+1} = (c_i + x_i + y_i) div b      %<'FontName',MSVFORMFONT>
% end                                       %<'FontName',MSVFORMFONT>
%
% Die  {\fontname{Courier}c_i}  nennt man bertrge.  Eine Hardware, die aus den zwei gegebenen Stellen der 
% Operanden  {\fontname{Courier}x_i}  und  {\fontname{Courier}y_i}  sowie dem bertrag  {\fontname{Courier}c_i}  die Stelle  {\fontname{Courier}z_i}  der Summe und den 
% bertrag in die nchste Stelle  {\fontname{Courier}c_{i+1}}  berechnet, nennt man Volladdierer.  Eine Simulation 
% in MATLAB liefert  {\fontname{Courier}fulladd} :
%
edit fulladd
%
% Mit diesem lsst sich ein serieller Addierer fr Stellensysteme zur Basis  {\fontname{Courier}q}
% sehr einfach realisieren wie hier in der Funktion  {\fontname{Courier}add} :
%
edit add                       % Programm in Editor
dbstop in 'add' at 2           % break in Zeile 2 
q = 10;                        % Basis = 10
reverse( add( reverse([0 3 1 8]) , reverse([0 0 5 3]) , 0 , 10 ))   % Programmaufruf
%
% Ein Addierer fr beliebig grosse ganze Zahlen zur Basis  {\fontname{Courier}q} , die als Strings 
% vorliegen, ist in der Funktion  {\fontname{Courier}stradd}  realisiert.  Negative Zahlen werden durch 
% ein voranstehendes {\fontname{Courier}"-"}  gekennzeichnet.  Fr effizientes Rechnen ist diese 
% Funktion natrlich nicht geeignet.
%
q = 10;              % Basis 
n = 15;              % Anzahl der Stellen 
x = randstr(q,n)     % String einer Zufallszahl 
y = randstr(q,n)     % noch ein String einer Zufallszahl
z = stradd(x,y,q)    % String der Summe der beiden Zufallszahlen
stradd(z,['-' num2str(str2num(x) + str2num(y),n+1)],q) % Prfung
%
% Der zu  stradd  passende Multiplizierer ist  {\fontname{Courier}strmult} .
%
q = 10;              % Basis 
n = 15;              % Anzahl der Stellen 
x = randstr(q,n)     % String einer Zufallszahl 
y = randstr(q,n)     % noch ein String einer Zufallszahl
z = strmult(x,y,q)   % String des Produktes der beiden Zufallszahlen
stradd(z,['-' num2str(str2num(x)*str2num(y),2*n)],q) % Prfung
%
% Als Beispiel liefert das folgende Programm eine Liste smtlicher Potenzen von  z  bis  n :
%
z = '2';
n = 250;
x = z;
y = '1';
s = '';
for k=1:n  y = strmult(x,y,10);  s = [s sprintf('%s^%3d = %s\n',z,k,y)]; end;
s
%
%
%\bfReprsentation negativer Zahlen durch Komplemente
%
% Durch Hinzufgung eines Vorzeichenbits zu der oben betrachteten Stellen-
% orientierten Darstellung knnte man negative und positive Zahlen reprsentieren.
% Bei der blichen Dezimalschreibweise wird das faktisch so gemacht.  Anstelle 
% der Symbole  {\fontname{Courier}0}  und  {\fontname{Courier}1}  fr das Vorzeichenbit werden dabei die Symbole {\fontname{Courier}+} und {\fontname{Courier}-} 
% benutzt.  Der Leser wird sich noch daran erinnern, wie er in der Grundschule 
% den im Vergleich zum Addieren komplizierteren Algorithmus zum Stellen-orientierten
% Subtrahieren lernte.  Dieses Subtrahieren, und damit die dazu bentigte Hardware 
% im Rechner, wird berflssig, wenn negative Zahlen als Komplemente reprsentiert 
% werden, die nicht negativ sind.
% 
% Seien  {\fontname{Courier}b}  die Basis der Darstellung sowie  {\fontname{Courier}n}  die Anzahl der Vorkommastellen 
% und  {\fontname{Courier}m}  die Anzahl der Nachkommastellen.  Dann definiert man fr eine gegebene 
% Zahl  {\fontname{Courier}z < b^n}  zwei Komplemente:
%
%{\bf{\fontname{Courier}b-}Komplement}:{\fontname{Courier}        K^{(n)}_b(z) = b^n - z} 
%
%{\bf{\fontname{Courier}(b-1)-}Komplement}:{\fontname{Courier}    K^{(n)}_{b-1}(z) = b^n - b^{-m} - z = K^{(n)}_b(z) - b^{-m}}
% 
% Beispiele:
%
b = 10                          % Basis des Stellensystems
n = 5                           % Anzahl der Vorkommastellen
m = 0                           % Anzahl der Nachkommastellen
z = 728                         % irgendeine Zahl < b^n
K_b = b^n - z                   % das b-Komplement
K_b1 = b^n - b^-m -z            % das (b-1)-Komplement
DK_b = num2basstr2(K_b,b,n,m)   % das b-Komplement in Darstellung zur Basis b
DK_b1 = num2basstr2(K_b1,b,n,m) % das (b-1)-Komplement in Darstellung zur Basis b
%
%% Die Resultate finden sich im MATLAB-Kommandofenster.
%% Weitere Beispiele lassen sich auf folgende Weise editieren und rechnen:
%% Bei obenliegendem Skriptfenster t1\_2 und selektiertem MATLAB-Block (er ist 
%% in magenta dargestellt) auf der Tastatur c (fr Copy) tippen.  Dann ffnet 
%% sich der Editor mit dem selektierten MATLAB-Block.  Hier kann beliebig 
%% editiert werden.  Unter "tools" findet sich im PullDown-Men die Auswahl 
%% "run" fr die Ausfhrung des editierten MATLAB-Codes.
%%
%% Berechnen Sie zur bung die Komplemente fr folgende Flle:
%
%      b     n      m         z            %<'FontName',MSVFORMFONT>
% -------------------------------------    %<'FontName',MSVFORMFONT>
%     10     2      3      (2.475)_{10}    %<'FontName',MSVFORMFONT>
%      2     4      2     (10.01)_2        %<'FontName',MSVFORMFONT>
%
%
% Wichtig ist die Eigenschaft, dass das Komplement des Komplements die Identitt ist:
%
% K_b^{(n)}(K_b^{(n)}(x) = b^n - K_b^{(n)}(x) = b^n - (b^n - x) = x   %<'FontName',MSVFORMFONT>
%
% K_{b-1}^{(n,m)}(K_{b-1}^{(n,m)}(x) = b^n - b^{-m} - K_{b-1}^{(n,m)}(x) = b^n - b^{-m} - (b^n - b^{-m} - x) = x   %<'FontName',MSVFORMFONT>
%
%
% Die Komplemente knnen im Stellensystem zur Basis  {\fontname{Courier}b}  auf einfache Weise 
% ohne Subtraktion direkt berechnet werden.  Mit den Darstellungen 
%
% {\fontname{Courier} b^n = (100{\bf...}0)_b      }( {\fontname{Courier}n}  Nullen nach der  {\fontname{Courier}1} )
%
% {\fontname{Courier}b^{-m} = (0.00{\bf...}01)_b    }( {\fontname{Courier}m-1}  Nullen zwischen {\bf.} und  {\fontname{Courier}1} )
%
% ergibt sich
%
% {\fontname{Courier}b^n - b^{-m} = \alpha\alpha{\bf...}\alpha.\alpha{\bf...}\alpha\alpha}   mit  {\fontname{Courier}\alpha = b - 1} 
%
%                ({\fontname{Courier}n}  Ziffern  {\fontname{Courier}\alpha}  vor dem Punkt und  {\fontname{Courier}m}  Ziffern  {\fontname{Courier}\alpha}  nach dem Punkt)
%
% Also
%             n                                                          %<'FontName',MSVFORMFONT>
% {\fontname{Courier}b^n - b^{-m}} = _{\fontsize{26}\Sigma} \alpha b^i   %<'FontName',MSVFORMFONT>
%           i=-m                                                         %<'FontName',MSVFORMFONT>
%
% Damit ist die Stellendarstellung des  {\fontname{Courier}(b-1)-}Komplements von
%
%      n                               %<'FontName',MSVFORMFONT>
% z = _{\fontsize{26}\Sigma} z_i b^i   %<'FontName',MSVFORMFONT>
%    i=-m                              %<'FontName',MSVFORMFONT>
%
% gegeben durch
%                         n                                                        %<'FontName',MSVFORMFONT>
% K_{b-1}^{(n,m)} = b^n - b^{-m} - z = _{\fontsize{26}\Sigma} (\alpha - z_i) b^i   %<'FontName',MSVFORMFONT>
%                       i=-m                                                       %<'FontName',MSVFORMFONT>
%
% Die Differenzen  {\fontname{Courier}\alpha - z_i}  sind fr jede Stelle unabhngig zu berechnen,
% weil  {\fontname{Courier}\alpha}  die hchstwertige Ziffer ist und  {\fontname{Courier}0 <= z_i <= \alpha} .  Das Borgen 
% bei der nchst hheren Stelle, welches das schriftliche Subtrahieren kompliziert 
% macht, entfllt hier also.
%
% Beispiele:
%
% dezimal         9999                 %<'FontName',MSVFORMFONT>
%                 -768                 %<'FontName',MSVFORMFONT>
%               ------                 %<'FontName',MSVFORMFONT>
%       K_{10-1}^{(4,0) } =  9231      %<'FontName',MSVFORMFONT>
%
% binr           1111                 %<'FontName',MSVFORMFONT>
%                -0110                 %<'FontName',MSVFORMFONT>
%               ------                 %<'FontName',MSVFORMFONT>
%       K_{10-1}^{(4,0) } =  1001      %<'FontName',MSVFORMFONT>
%
% Im Fall des Binrsystems ist das  {\fontname{Courier}(b-1)-}Komplement (also das {\fontname{Courier}1-}Komplement)
% besonders einfach zu ermitteln, nmlich durch Invertierung aller Stellen.
%
% Auch das  {\fontname{Courier}b-}Komplement erhlt man ohne Subtraktion nach
%
% K_b^{(n)}(z) = K_{b-1}^{(n,m)} + b^{-m}     %<'FontName',MSVFORMFONT>
%
% Im Fall des Binrsystems invertiert man also alle Stellen und addiert an der 
% niederwertigsten Stelle eine  {\fontname{Courier}1} . 
%
% Ohne weitere Kennzeichnung werden die Komplemente und die nicht negativen Zahlen 
% in dem selben System reprsentiert.  Damit man sie unterscheiden kann, werden zwei 
% (fast) gleich grosse Bereiche festgelegt.  Im Fall des Binrsystems sind dann alle 
% {\fontname{Courier}n}-Bit-Wrter, deren Ganzzahlinterpretation kleiner als  {\fontname{Courier}b^{n-1}}  ist, eben so als 
% nicht negative Ganzzahl zu interpretieren.  Andernfalls liegt die Binrdarstellung 
% eines Komplements vor.  Dies ist hier direkt am hchstwertigen Bit zu erkennen. 
% Das Bit wird deshalb bisweilen als Vorzeichen-Bit bezeichnet.  Man vergesse aber 
% nie, dass die folgenden Bits ein Komplement reprsentieren und nicht den Betrag 
% der Zahl wie bei der blichen Dezimalschreibweise.
%
% Die Aufteilung der Interpretation von  {\fontname{Courier}n-} stelligen Reprsentationen zur Basis  {\fontname{Courier}b}   
% wird mit der Funktion  {\fontname{Courier}bcomplement}  interaktiv dargestellt.  Die Basis   {\fontname{Courier}1 < q < 65} , 
% die Anzahl der Stellen  {\fontname{Courier}0 < n <6}  und die maximale positive Zahl  {\fontname{Courier} 1 <= m}  knnen 
% interaktiv gendert werden.  Bei nderungen von  {\fontname{Courier}b}  oder  {\fontname{Courier}n}  wird automatisch der 
% bliche Wert fr  {\fontname{Courier}m}  eingestellt.  Man knnte aber  {\fontname{Courier}m}  auch anders festlegen, um z.B. 
% den Bereich der positiven Zahlen auf Kosten der negativen zu vergrssern.  Beim 
% Binrsystem ginge dann die Interpretation des hchstwertigen Bits als Vorzeichen 
% verloren.
%
bcomplement
%
%
%\bfSubtraktion
%
% Die Operanden  {\fontname{Courier}x}  und  {\fontname{Courier}y}  seien als nicht negative Zahlen darstellbar.  
% Es gelte also
%
% 0 \leq x \leq b^{n-1} ;   0 \leq y \leq b^{n-1}    %<'FontName',MSVFORMFONT>
%
% Ausserdem sei im ersten Fall  {\fontname{Courier}x \geq y} .
%
% Die Subtraktion  {\fontname{Courier}z = x - y}  erfolgt formal durch
%
% z = x + K_b^{(n)}(y) = x + b^n - y    %<'FontName',MSVFORMFONT>
%
% Die Realisierung ist begrenzt auf  {\fontname{Courier}n}  Stellen, so dass dort gilt:
%
% Z = (x + K_b^{(n)}(y)) mod b^n = x - y    %<'FontName',MSVFORMFONT>
%  
% Wenn  {\fontname{Courier}x ,  y}  und  {\fontname{Courier}x - y}  mit  {\fontname{Courier}n}  Stellen darstellbar sind, wird das Resultat also
% korrekt interpretiert.
%
% m zweiten Fall sei  {\fontname{Courier}x < y} .  Dann ergibt sich
%
% Z = (x + K_b^{(n)}(y)) mod b^n = (b^n - (y - x)) mod b^n = K_b^{(n)}(y - x)    %<'FontName',MSVFORMFONT>
%
% Diese Realisierung der Subtraktion liefert also korrekt das  {\fontname{Courier}b-}Komplement von  {\fontname{Courier}y - x} .
%
% Eine interaktive Demo fr die Addition und Subtraktion von Zahlen in Stellen-
% Reprsentation unter Verwendung der Komplemente gibt
%
demofixpointadd
%
% Die Addition zweier korrekt dargestellter positiver Zahlen wie auch die Addition 
% zweier korrekt als  {\fontname{Courier}b-}Komplement dargestellter Zahlen kann ein Resultat ergeben, 
% das im falschen Bereich liegt und damit falsch interpretiert wird.  Diese Situation 
% wird von einer richtig entworfenen Hardware des Addierers erkannt.  Die Warnung 
% wird leider hufig von der Software ignoriert.  Der bislang spektakulrste Fall 
% ist sicherlich der Absturz der ersten Ariane-5-Rakete, bei der man aus gutem 
% Grund die bewhrte alte Bord-Software laufen liess.  Allerdings wird bei der 
% Ariane 5 deren enormer Schub (wie beim Space-Shuttle) schon wenige Sekunden nach 
% den Start durch Schrglage des Fahrzeugs fr die Beschleunigung in der horizon-
% talen Komponente ausgenutzt.  So erreichte die erste Raketenstufe korrekt geplant 
% schon nach kurzer Zeit eine positive Horizontalkomponente der Geschwindigkeit, 
% die bei der begrenzten Reprsentation in smtlichen Bordrechnern in den Bereich 
% der Komplemente lief.  Das Navigationsprogramm bemerkte sofort:  wir fliegen in 
% die falsche Richtung und riss die Rakte herum, wodurch sie zu Schaden kam und 
% gesprengt werden musste.
%
% Eine Interaktive Darstellung der Reprsentation natrlicher Zahlen im Stellensystem 
% zur Basis   {\fontname{Courier}1 < b < 65}  und der Operationen mit zwei Operanden liefert die 
% Funktion  {\fontname{Courier}inforepres} .  Die Graphik soll durch interaktives Spielen mit den Operanden 
% und der Operation  ({\fontname{Courier}+  -  *  div  rem  max  min  <  <=  >  >= })  zeigen, 
% dass das Resultat von Operationen mit in der gewhlten Form (Basis und Stellenzahl) 
% darstellbaren Operanden nicht immer auch in dieser Form darstellbar ist.  Wenn die 
% Hardware so realisiert ist, dass sie diese Situation nicht erkennt (Designfehler), 
% oder wenn die Software die Warnungen der Hardware ignoriert (leider sehr hufiger (Fall), 
% dann ist das Resultat falsch, und zwar ohne dass dies ersichtlich ist. 
%
inforepres
%
% Ein Beispiel fr die Realisierung einer Festkomma-Arithmetik ohne Prfung 
% von berlufen liefert Turbo-Pascal.  Zur Demonstration dient hier ein 
% kleines Pascal-Programm, welches der Reihe nach um Eingabe des ersten und 
% des zweiten Operanden und dann der Operation bittet. Anschliessend wird das 
% Resultat ausgegeben (Abbruch mit 's' als Operation):
%
edit festkomm.pas
dos  festkomm.exe
%% Wenn festkomm.exe nicht gefunden wurde, bitte im Kommandofenster den 
%% Befehl mit dem vollstndigen Pfad angeben.
%
%% Probieren Sie z.B. folgende Operationen:
% 
% {\fontname{Courier}2 + 3;  100*200;  200*200;  20000 + 30000;  -1 + (-32768)}
%
% Multipliziert man die natrlichen Zahlen  {\fontname{Courier}1 ... 10}  der Reihe nach mit obigem 
% Programm, so ergeben sich die Fakultten:
% 
%   n          n! korrekt   n! berechnet           %<'FontName',MSVFORMFONT>
% --------------------------------------           %<'FontName',MSVFORMFONT>
%   1           1            1                     %<'FontName',MSVFORMFONT>
%   2           2            2                     %<'FontName',MSVFORMFONT>
%   3           6            6                     %<'FontName',MSVFORMFONT>
%   4          24           24                     %<'FontName',MSVFORMFONT>
%   5         120          120                     %<'FontName',MSVFORMFONT>
%   6         720          720                     %<'FontName',MSVFORMFONT>
%   7        5040         5040                     %<'FontName',MSVFORMFONT>
%   8       40320       -25216                     %<'FontName',MSVFORMFONT>
%   9      362880       -30336                     %<'FontName',MSVFORMFONT>
%  10     3628800        24320                     %<'FontName',MSVFORMFONT>
%
% Ab  8!  sind smtliche Fakultten falsch.
%
%% Vergleichen Sie einige Additionsergebnisse von  festkomm.pas  mit dem Resultat der 
%% selben Rechnung mit  demofixpointadd  bei  16-stelliger Binrreprsentation.
%