%
%
%5.2.3  Bitfehlerrate%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Bei der Speicherung oder bertragung auftretende Fehler haben physikalische 
% Ursachen.  Sie greifen in der untersten Ebene der Hierarchie der Reprsentation ein,
% also dort, wo die digitalisierte Information durch kontinuierliche physikalische 
% Werte reprsentiert werden.  Die Fehler selbst sind hufig additive Zufallsgrssen.  
% Es gibt zur Decodierung eines mglicherweise fehlerhaften Codeworts zwei Wege:
%
% (a)  Die Bits des Codewortes werden individuell interpretiert.  Darauf erfolgt die 
%       digitale Decodierung mit mglicher Korrektur.
%
% (b)  Das gesamte Codewort wird analog empfangen, also  n  physikalische Werte 
%       gemessen anstelle der Interpretation als Bits.  Die Entscheidung fr ein 
%       Codewort fllt aufgrund des kleinsten euklidischen Abstands zwischen dem 
%       empfangenen Wort und dem Codewort.
%
% Wir beschrnken uns hier auf die Bitfehlerwahrscheinlichkeit der Decodierung fr 
% den Fall (a) bei Blockcodes.  Der Fall (b) ist aber generell besser.
%
% Kann der {\fontname{Courier}(n,k)-}Code  {\fontname{Courier}r}  Bits korrigieren, so ist die Wortfehlerwahrscheinlichkeit gegeben 
% durch die Summe der Wahrscheinlichkeiten,  {\fontname{Courier}r+1, r+2, ... n}  Bitfehler unter den 
% empfangenen  {\fontname{Courier}n}  Bits vorzufinden.  Wir berechnen diese Binomialverteilung direkt durch 
% die Summe der Terme nach der Newton'schen Formel 
%
%          n                                                             %<'FontName',MSVFORMFONT>
%     p_w = {\fontsize{30}_\Sigma}  n!/(m!*(n-m)!) * p^m * (1-p)^{n-m}   %<'FontName',MSVFORMFONT>
%         m=r+1                                                          %<'FontName',MSVFORMFONT>
%
% Hufig dominiert der Term mit   {\fontname{Courier}m = r + 1}   alle anderen.  Das folgende Bild zeigt die 
% Binomialverteilung fr   {\fontname{Courier}n = 7}   bei verschiedenen Werten fr die Bitfehlerwahrscheinlichkeit  {\fontname{Courier}p} .  
% Der  {\fontname{Courier}(7,4)-}Hamming-code kann maximal eines von 7 Codewortbits korrigieren, d.h.   {\fontname{Courier}r = 1} .  
%
fehl_vert(7,[0.1,0.01; 0.001,0.0001],1);
%
% Das entsprechende Diagramm fr den Dreibitfehlerkorrigierenden  {\fontname{Courier}(23,12)}-Golay-code ist :
%
fehl_vert(23,[0.1,0.01; 0.001,0.0001],1);
%
% Die Wortfehlerwahrscheinlichkeit ergibt sich aus den Diagrammen durch Summation aller
% Werte fr   {\fontname{Courier}m = r+1,...,n} .  Um nach der Korrektur verbleibende Bitfehlerwahr-
% scheinlichkeiten vergleichen zu knnen, muss die Wortfehlerwahrscheinlichkeit in die 
% Bitfehlerwahrscheinlichkeit gewandelt werden.  Das ist allgemein nur approximativ mglich.  
% Wir nehmen den durchaus hufigen schlimmsten Fall an, dass ein falsch decodiertes Empfangswort 
% keine hnlichkeit mit dem korrekten aufweist.  Von den decodierten  {\fontname{Courier}k} Informationsbits sind 
% daher im Mittel  {\fontname{Courier}k/2}  falsch oder positiv ausgedrckt:  selbst im Fall eines Decodierfehlers 
% werden noch  {\fontname{Courier}k/2}  Bits zufllig richtig sein.  Deshalb ist die Bitfehlerwahrscheinlichkeit fr 
% decodierte Bits
%
% P_b = p_w/2   %<'FontName',MSVFORMFONT>
%
% Die Funktion  {\fontname{Courier}harddecodeber}  zeichnet die Wort- und Bitfehlerwahrscheinlichkeit ber der 
% Bitfehlerrate des Kanals:
%
help harddecodeber
%
% Wir sehen uns drei Flle an:  (1)  {\fontname{Courier}(7,4)-} Hamming-Code mit  {\fontname{Courier}d = 3} :
%
harddecodeber(7,3)
%
% (2)  {\fontname{Courier}(23,12)-} Golay-Code mit  {\fontname{Courier}d = 7} :
%
harddecodeber(23,7)
%
% (3)  {\fontname{Courier}(2048,8)-} Randomcode mit  {\fontname{Courier}d = 1005} :
%
harddecodeber(2048,1005)
%
% Wesentlich ist bei allen Codes, dass die resultierende Bitfehlerrate bei kleinen Kanal-
% fehlerraten sehr viel kleiner als die Kanalfehlerrate ist.
%