%
%
%6.1  Grundbegriffe der Algebra%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Bei der Modellierung verschiedener Problemstellungen findet man hufig sehr 
% hnliche mathematische Grundstrukturen.  Es lohnt sich, diese intensiv zu 
% untersuchen, weil man dann vieles auf das schon bekannte zurckfhren kann. 
% Dieses Kapitel soll keine Einfhrung in die Algebra endlicher Mengen sein. 
% Vielmehr wird hier das an Mathematik zusammengestellt, was fr die folgenden 
% Kapitel erforderlich ist.  Auf Beweise wird zumeist verzichtet.  In Lehrbchern 
% ber dieses Gebiet wird sich dem interessierten Leser eine faszinierende Welt 
% von Zusammenhngen erffnen, die wir hier nicht darstellen knnen.  Vorausgesetzt
% wird hier ein Grundverstndnis der Mengenlehre einschliesslich solcher Begriffe 
% wie Relation und Abblidung sowie der Umgang mit der blichen mathematischen 
% Notation.
%
% {\itDefinition}:  Das  {\bfkartesische Produkt}  zweier Mengen  {\fontname{Courier}A}  und  {\fontname{Courier}B},   
% in Zeichen  {\fontname{Courier}A\timesB} ,  ist die Menge
%
%       A\timesB = \{(a,b) | a \in A  und  b \in B\} . %<'FontName',MSVFORMFONT>
%
% Das kartesische Produkt  {\fontname{Courier}A\timesA}  einer Menge  {\fontname{Courier}A}  mit sich bezeichnet man 
% kurz mit  {\fontname{Courier}A^2} .
%
% {\itDefinition}:  {\fontname{Courier}A}  sei eine Menge.  Eine Abbildung   {\fontname{Courier}f : A^2 \rightarrow A}  
% heisst eine  {\bfinnere Verknpfung}  von  {\fontname{Courier}A} .
%
% Fr innere Verknpfungen benutzt man meist die  {\bfInfixnotation} :
%
% Gilt bei einer inneren Verknpfung 
%
%            {\fontname{Courier}f : (a,b) \rightarrow  c}    fr    {\fontname{Courier}a,b,c \in A} ,  
%
% dann schreibt man mit einem Verknpfungssymbol, etwa  {\fontname{Courier}\o} , anstelle von
%
%            c = f((a,b))      %<'FontName',MSVFORMFONT>
% auch   
%            c = a \o b .      %<'FontName',MSVFORMFONT>
%
% Neben der  {\bfPrfixnotation} wie z.B. bei  {\fontname{Courier}sin(x)}  und der  {\bfInfixnotation}  wie bei  {\fontname{Courier}a + b} 
% ist fr einige Operationen die  {\bfPostfixnotation}  blich, z.B. bei der Fakultt  {\fontname{Courier}n!} , bei der 
% Transposition von Matrizen  {\fontname{Courier}A'}  oder  {\fontname{Courier}A^T}  und Insbesondere bei der Indizierung.  Auch 
% Programmiersprachen haben die geschichtlich gewachsenen Notationen bernommen. 
% Ein Rechnerbefehl wie z.B. 
%
%            x(3) = sin(pi/4)  %<'FontName',MSVFORMFONT>
%
% enthlt Postfix-, Prfix- und Infixnotation.  LISP und Verwandte sind eine Ausnahme.
% 
% Verknpfungen in der Menge der ganzen Zahlen sind die Addition und die 
% Multiplikation mit den blichen Infixsymbolen  {\fontname{Courier}+}  und  {\fontname{Courier}\cdot}  bzw.  {\fontname{Courier}\times} . 
% Die Subtraktion ist in der Menge der natrlichen Zahlen keine innere Verknpfung, 
% wohl aber in der Menge der ganzen Zahlen.  In endlichen Mengen kann man innere 
% Verknpfungen durch Tabellen festlegen.  Dieselbe innere Verknpfung der 
% Menge  {\fontname{Courier}\{0,1\}} ist hier in zwei blichen Tabellenformen angegeben:
%
%            x \o y  =  z                  y     %<'FontName',MSVFORMFONT>
%           --------|----             \o | 0  1  %<'FontName',MSVFORMFONT>
%            0   0  |  0             ---|------  %<'FontName',MSVFORMFONT>
%            0   1  |  1           x  0 | 0  1   %<'FontName',MSVFORMFONT>
%            1   0  |  0              1 | 0  0   %<'FontName',MSVFORMFONT>
%            1   1  |  0                         %<'FontName',MSVFORMFONT>
%
%
% {\itDefinition}:  Eine Menge mit Verknpfungen heisst  {\bfalgebraische Stuktur} .
%
% Die Eigenschaften der Verknpfungen geben der Menge ihre Struktur.  Die 
% Eigenschaften werden durch Axiome  beschrieben.  In der Mathematik werden 
% Axiome einfach gesetzt und Algebraische Strukturen untersucht, die ihnen 
% gengen.  In den Naturwissenschaften versucht man umgekehrt Zusammenhnge 
% formal zu erfassen.  Man findet dort hufig die bekannten algebraischen 
% Strukturen indem man die Gltigkeit der Axiome prft.
%
% {\itDefinition}:  (A,\otimes)  und  (B,\oplus)  seien algebraische Strukturen.
% Eine Abbildung  f : A \rightarrow B  heisst ein  {\bfIsomorphismus}  von  
% (A,\otimes)  und  (B,\oplus) , wenn 
%
%            f(a\otimesb) = f(a) \oplus f(b)   \forall  a,b \in A   %<'FontName',MSVFORMFONT>
%
% Wenn sich also herausstellt, dass eine zu untersuchende Menge mit ihren 
% inneren Verknpfungen isomorph zu einer bekannten Struktur ist, dann ist 
% die Algebra bertragbar und die Untersuchung abgeschlossen.  Wird fr alle 
% Elemente einer Menge auf einem Rechner eine Reprsentation gefunden und 
% eine Realisierung der inneren Verknpfung derart, dass der Nachweis gleicher 
% algebraischer Struktur in der abstrakten Menge und ihrer Reprsentation 
% gelingt, so ist die Informationstreue bewiesen. 
%
