%
%
%6.2  Gruppe %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
%
% Eine sehr einfache algebraische Struktur ist die Gruppe:
%
% {\itDefinition}:  Eine nichtleere Menge  {\fontname{Courier}G}  mit einer inneren 
% Verknpfung  {\fontname{Courier}\o}  heisst eine  {\bfGruppe} , wenn die folgenden Axiome 
% erfllt sind:
%
% {\bfG1 Assoziativgesetz} :
%
% (a \o b) \o c = a \o (b \o c)   \forall  a,b,c \in G   %<'FontName',MSVFORMFONT>
%
% {\bfG2 Existenz eines neutralen Elements} :
%
% Es gibt genau ein  {\fontname{Courier}e \in G} , so dass   {\fontname{Courier}e \o a = a \o e = a    \forall a \in G}
%
% {\bfG3 Existenz der inversen Elemente} :
%
% Zu jedem  {\fontname{Courier}a \in G}  gibt es genau ein  {\fontname{Courier}a^{-1} \in G}  mit   {\fontname{Courier}a^{-1} \o a = a \o a^{-1} = e}
%
%
% {\bfBeispiel}:
%
% In der Menge  {\fontname{Courier}\{A,B,C\}}  sei eine innere Verknpfung definiert durch folgende Tabelle:
%
%                 x      %<'FontName',MSVFORMFONT>
%           \o | A B C   %<'FontName',MSVFORMFONT>
%          ---|-------   %<'FontName',MSVFORMFONT>
%           A | C A B    %<'FontName',MSVFORMFONT>
%       y   B | A B C    %<'FontName',MSVFORMFONT>
%           C | B C A    %<'FontName',MSVFORMFONT>
%
% Dem Leser sei als bungsaufgabe die berprfung von G1, G2 und G3 berlassen. 
% Die hier definierte innere Verknpfung erfllt berdies das
%
% {\bfG4 Kommutativgesetz} :
%
% a \o b = b \o a   \forall  a,b \in  G  %<'FontName',MSVFORMFONT>
%
% Wenn in einer Gruppe das Kommutativgesetz gilt, liegt eine  {\bfkommutative Gruppe}  
% vor.  Sie wird auch als  {\bfAbelsche Gruppe}  bezeichnet.
%
%
% Die einfachste Gruppe ist die triviale Gruppe aus einem einzigen Element, 
% das mit sich selbst verknpft wieder sich selbst ergibt.  Der Nachweis 
% von  G1 bis G4 ist trivial.
%
% Die fr die technische Informatik wichtigste Gruppe ist  {\fontname{Courier}(\{0,1\},+)} :
%
%               x          %<'FontName',MSVFORMFONT>
%           + | 0 1        %<'FontName',MSVFORMFONT>
%          ---|-----       %<'FontName',MSVFORMFONT>
%       y   0 | 0 1        %<'FontName',MSVFORMFONT>
%           1 | 1 0        %<'FontName',MSVFORMFONT>
%
% Die hier mit dem Infixsymbol  +  definierte innere Verknpfung wird auch als
% exklusives Oder bezeichnet.
%
% Bei kleinen endlichen Mengen kann man den Nachweis der Gruppenaxiome dem 
% Rechner berlassen, der sturheil smtliche Kombinationen durchprobiert:
%
[ istgruppe, G1_4, neutrales_el , inverse_el ] = isgru([1 2; 2 1])
%
%% Parameter von  isgru  ist die Tabelle der inneren Verknpfung in Indexform,
%% d.h. die Elemente der Menge sind in beliebiger Reihenfolge durchnummeriert 
%% von 1 bis n .   Prfen Sie mit  isgru  durch entsprechende Umsetzung auch die 
%% Gruppenaxiome fr die oben als Beipiel angegebene Verknpfungstabelle der 
%% Menge \{A,B,C\}  und prfen Sie ebenfalls die triviale Menge.
%
