%
%
%6.4  Vektorraum %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% {\itDefinition} :  {\fontname{Courier}A, B}  seien Mengen.  Unter einer  {\bfusseren Verknpfung}  
% von  B  mit  A  verstehen wir eine Abbildung   {\fontname{Courier}f : A\cdotB \rightarrow B} .
%
% {\itDefinition} :  {\fontname{Courier}K}  sei ein Krper mit den inneren Verknpfungen  +  und  \cdot .  
% Eine additive Abelsche Gruppe  {\fontname{Courier}V}  mit der inneren Verknpfung  \oplus  und mit 
% einer usseren Verknpfung  {\fontname{Courier}K\otimesV \rightarrow V} , die jedem Paar  {\fontname{Courier}(k,a)}  mit  {\fontname{Courier}k\inK}  und  
% {\fontname{Courier}a\inV}  genau ein  {\fontname{Courier}k\otimesa\inV}  zuordnet, heisst ein  {\bflinearer Raum}  oder  {\bfVektorraum}  
% ber  {\fontname{Courier}K} , wenn die folgenden Axiome erfllt sind:
%
% V1    k\otimes(h\otimesa) = (k\cdoth)\otimesa        \forall  k,h \in K ,  \forall  a \in V  %<'FontName',MSVFORMFONT>
% V2    (k + h)\otimesa = k\otimesa \oplus h\otimesa   \forall  k,h \in K ,  \forall  a \in V  %<'FontName',MSVFORMFONT>
% V3    k\otimes(a \oplus b) = k\otimesa \oplus k\otimesb   \forall  k,h \in K ,  \forall  a \in V  %<'FontName',MSVFORMFONT>
% V4    1\otimesa = a                   \forall  k,h \in K ,  \forall  a \in V  %<'FontName',MSVFORMFONT>
%
% Die Elemente von  {\fontname{Courier}V}  heien  {\bfVektoren} , die von  {\fontname{Courier}K}  {\bfSkalare} .  Die uere Verknpfung  \otimes
% nennen wir linksseitige Multiplikation der Elemente von  {\fontname{Courier}V}  mit den Elementen von  {\fontname{Courier}K} .
%
% Sehr wichtige Beispiele linearer Rume sind die n-fachen kartesischen Produkte  
% {\fontname{Courier}K\timesK\times ... \timesK = K^n}  eines Krpers  {\fontname{Courier}K}  mit sich.
% Die innere Verknpfung von  {\fontname{Courier}V}  wird in diesem Fall auf die Addition in  {\fontname{Courier}K}
% zurckgefhrt:
%
% Mit  {\fontname{Courier}a = (a_1, a_2)}  und  {\fontname{Courier}b = (b_1, b_2)} , wo  {\fontname{Courier}a_1, a_2, b_1, b_2 \in K}  gilt
%
% {\fontname{Courier}a \oplus b = (a_1 + b_1, a_2 + b_2)}
%
% Die ussere Verknpfung ist entsprechend definiert:
%
% {\fontname{Courier}k\otimesa = (k\cdota_1, k\cdota_2)}
%
% Der Nachweis, dass die Axiome des Vektorraumes mit diesen Festlegungen immer erfllt 
% sind, sei dem Leser als einfache bung berlassen.
%
% Die Krperelemente  {\fontname{Courier}a_1, a_2, ...}  eines solchen Vektors  {\fontname{Courier}a = (a_1, a_2, ... )}  nennt 
% man  {\bfKomponenten} .
%
% Vektorrume sind so vielseitig einsetzbar, da sie als eigene mathematische Disziplin die 
% Lineare Algebra begrnden.  Wir werden nur weniges aus diesem Gebiet bentigen (z. B. 
% die Matrizenmultiplikation), das sich aber kaum ohne Gesamtdarstellung verstndlich sagen 
% lt.  Wir verweisen deshalb auf die sehr umfangreiche Lehrbuchliteratur.
%
% Fr die Technische Informatik wichtig sind insbesondere die Kartesischen Produkte 
% der Menge  {\fontname{Courier}\{0,1\}} .  Ihre Elemente sind Vektoren aus je  n Bits.  Die innere 
% Verknpfung ist definiert wie oben erlutert und entspricht einem exklusiven 
% Oder Komponentenweise.  Fr das exklusive Oder gibt es in MATLAB die Funktion  
% {\fontname{Courier}xor}  in Prfixnotation.  quivalent ist aber auch das Ungleich in Infixnotation (~=).  
% Die Multiplikation im GF(2) entspricht dem logischen Und (&).  Damit ist die lineare 
% Algebra ber dem GF(2) sehr einfach in MATLAB realisierbar:
%
a = [0 1 1 1 0 1 0 0]    % ein Vektor
b = [0 0 0 1 1 1 1 0]    % ein zweiter Vektor
c = a ~= b               % Vektoraddition
d = 0 & a                % ussere Verknpfung mit 0
f = 1 & a                % ussere Verknpfung mit 1
%% Die Resultate stehen im Kommandofenster
%
%
%% Hier fehlt noch eine Kurzfassung der Themen Basisvektoren, Transformation, Matrix, etc.
%
% Lineare Transformationen lassen sich mit Matrizen sehr einfach formulieren 
% und realisieren.  Ein Beispiel gibt die folgende Graphik, in der ein durch 
% fnf Eckpunkte definiertes zweidimensionales Objekt daduch gedreht wird, dass
% die Matrix der fnf Punkte mit der 2\times2-Drehmatrix  A  vormultipliziert 
% wird:
%
p  = [ -0.5  +0.5  -0.5  +0.5  0;  0  0  1  1  1.5 ];  % Eckpunkte der Graphik
w  = 70/180*pi;                                        % Drehwinkel 70
A  = [cos(w)  -sin(w);  sin(w)  cos(w)];               % Transformationsmatrix
q  = A*p;                                              % gedrehte Punkte       
pp = [p(:,1) p(:,2) p(:,4) p(:,5) p(:,3) p(:,4) p(:,1) p(:,3) p(:,2)]; % Reihenfolge der Punkte
qq = [q(:,1) q(:,2) q(:,4) q(:,5) q(:,3) q(:,4) q(:,1) q(:,3) q(:,2)]; % Reihenfolge der Punkte
fh = fullscreen('Drehung');
patch(pp(1,:),pp(2,:),'g')                             % Objekt ungedreht, grn
patch(qq(1,:),qq(2,:),'r')                             % Objekt gedreht, rot
axis([-2 +2 -1.5 +1.5]);  axis off
%
%
% Lsung von linearen Gleichungssystemen im GF(2) :
%
A = [1 1 0; 1 1 1; 0 1 1]

r = randb(3)';          % rechte Seite des Gleichungssystems

x = bingausselim(A,r)   % Lsung des Gleichungssystems  A*x = r

mod(A*x+r,2)            % Prfung der Lsung
%
%

