%
%
%6.5  Innere Verknpfungen der Menge \{0,1\} %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-12,'Color',MSVTITLCOLOR>
%
%
%
% Verknpfungen in endlichen Mengen lassen sich durch Tabellen definieren.  Im Falle 
% der Menge  \{0,1\}  hat die Tabelle die Form
%
%               x          %<'FontName',MSVFORMFONT>
%           + | 0 1        %<'FontName',MSVFORMFONT>
%          ---|-----       %<'FontName',MSVFORMFONT>
%       y   0 | a b        %<'FontName',MSVFORMFONT>
%           1 | c d        %<'FontName',MSVFORMFONT>
%
% Hierin kommen die vier Konstanten  a, b, c, d \in \{0,1\}  vor.  Lsst man 
% smtliche Kombinationen der  a, b, c, d  zu, so ergeben sich  16  verschiedene 
% innere Verknpfungen, von denen sich allerdings einige als trivial oder unecht 
% erweisen.  Wir listen zunchst alle auf:
%
%
%
%
%
%
%  a b c d  Bezeichnung       Notation  Alternativnotation MATLAB-Notation   %<'FontName',MSVFORMFONT>
% ------------------------------------------------------------------------   %<'FontName',MSVFORMFONT>
%  0 0 0 0  NULLfunktion        0                              0             %<'FontName',MSVFORMFONT>
%  1 0 0 0  NOR                 \neg(x\cupy)                        ~(x|y)   %<'FontName',MSVFORMFONT>
%  0 1 0 0  Inhibition          x>y                            x>y           %<'FontName',MSVFORMFONT>
%  1 1 0 0  NICHT y             \negy              y'             ~y         %<'FontName',MSVFORMFONT>
%  0 0 1 0  Inhibition          x<y                            x<y           %<'FontName',MSVFORMFONT>
%  1 0 1 0  NICHT x             \negx              x'             ~x         %<'FontName',MSVFORMFONT>
%  0 1 1 0  XOR                 x\oplusy             x\neqy           x~=y   %<'FontName',MSVFORMFONT>
%  1 1 1 0  NAND                \neg(x\capy)                        ~(x&y)   %<'FontName',MSVFORMFONT>
%  0 0 0 1  UND                 x\capy                           x&y         %<'FontName',MSVFORMFONT>
%  1 0 0 1  quivalenz          \neg(x\oplusy)         x=y            x==y   %<'FontName',MSVFORMFONT>
%  0 1 0 1  Identitt x         x                              x             %<'FontName',MSVFORMFONT>
%  1 1 0 1  Implikation         x\geqy             x\leftarrowy           x>=y   %<'FontName',MSVFORMFONT>
%  0 0 1 1  Identitt y         y                              y             %<'FontName',MSVFORMFONT>
%  1 0 1 1  Implikation         x\leqy             x\rightarrowy           x<=y  %<'FontName',MSVFORMFONT>
%  0 1 1 1  ODER                x\cupy                            x|y         %<'FontName',MSVFORMFONT>
%  1 1 1 1  EINSfunktion        1                              1             %<'FontName',MSVFORMFONT>
%
% Trivial sind die NULLfunktion und die EINSfunktion, die gar nicht von den zu verknpfenden 
% Elementen abhngen, und unecht sind alle Funktionen, die nur von einem der beiden 
% Elemente abhngen.  Das sind  NICHTx, NICHTy, Identitt x und Identitt y.  Es 
% verbleiben folgende echte Verknpfungen, fr die wir die Gltigkeit der Gruppenaxiome 
% mit auflisten:
%
%  a b c d  Bezeichnung  Notation     G1 G2 G3 G4        %<'FontName',MSVFORMFONT>
% -----------------------------------------------        %<'FontName',MSVFORMFONT>
%  1 0 0 0  NOR          \neg(x\cupy)                x   %<'FontName',MSVFORMFONT>
%  0 1 0 0  Inhibition   x>y                             %<'FontName',MSVFORMFONT>
%  0 0 1 0  Inhibition   x<y                             %<'FontName',MSVFORMFONT>
%  0 1 1 0  XOR          x\oplusy          x  x  x  x    %<'FontName',MSVFORMFONT>
%  1 1 1 0  NAND         \neg(x\capy)                x   %<'FontName',MSVFORMFONT>
%  0 0 0 1  UND          x\capy          x  x     x      %<'FontName',MSVFORMFONT>
%  1 0 0 1  quivalenz   \neg(x\oplusy)       x  x  x  x %<'FontName',MSVFORMFONT>
%  1 1 0 1  Implikation  x\geqy                          %<'FontName',MSVFORMFONT>
%  1 0 1 1  Implikation  x\leqy                          %<'FontName',MSVFORMFONT>
%  0 1 1 1  ODER         x\cupy          x  x     x      %<'FontName',MSVFORMFONT>
%
% Eine Algebra, in der Gleichungssysteme lsbar sein sollen, bentigt eine innere 
% Verknpfung mit inversen Elementen.  Nur das XOR und die quivalenz bieten dies. 
% Die Codierungstheorie arbeitet deshalb mit der GF(2)-Algebra.
%
% Fr die Realisierung von beliebigen Funktionen ist es wichtig zu wissen, 
% welche dieser Verknpfungen unverzichtbar sind oder mit welchen Untermengen 
% man smtliche Funktionen realisieren kann.
%
% {\itDefinition}:   Eine Menge  {\fontname{Courier}M}  von inneren Verknpfungen von  {\fontname{Courier}A}  und 
% einstelligen Operationen heisst funktional vollstndig, wenn mit ihnen alle 
% Funktionen  {\fontname{Courier}f : A^n \rightarrow A}  geschrieben werden knnen.
%
% Beispiele von funktional vollstndigen Mengen fr  {\fontname{Courier}B = \{0,1\}}
% ----------------------------------------------------------------------------------
%
% M = \{NAND\}                         bliche Computer-Logik
%
% M = \{NOR\}                           frher zum Teil bei ECL-Logik verwendet
%
% M = \{UND, NICHT\}
%
% M = \{ODER, NICHT\}
%
% M = \{XOR, UND, EINS\}        endlicher Krper GF(2)
%
% M = \{UND, ODER, NICHT\}   Boolesche Algebra
%
% Die bliche Computerlogik arbeitet also mit einer schwer handhabbaren Algebra, in 
% der nur  G4  gilt.  Zur Entscheidungsfindung innerhalb von Rechenprogrammen und 
% auch beim Entwurf von Hardware wird dagegen die Boolesche Algebra verwendet, 
% in der es keine einheitlichen Inversen Elemente gibt, so dass keine eleganten Verfahren 
% zur Lsung von Gleichungssystemen mglich sind.  Der folgende Abschnitt beschftigt 
% sich mit der Booleschen Algebra. Die Funktionale Vollstndigkeit der Booleschen 
% Algebra wird im Kapitel 7 gezeigt.  Die Funktionale Vollstndigkeit der brigen 
% Mengen lsst sich daraus ableiten durch Realisierung von UND, ODER und NICHT 
% durch die jeweilige Verknpfungsmenge.
%