%
%
%6.6  Boolesche Algebra %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Auch die Boolesche Algebra wird wie die lineare Algebra axiomatisch begrndet:
%
% {\itDefinition}:  Eine algebraische Struktur  {\fontname{Courier}\{B;\cap,\cup\}}  auf einer wenigstens 
% zweielementigen Menge  {\fontname{Courier}B}  mit den Elementen  {\fontname{Courier}a, b, c \in B}  und den inneren 
% Verknpfungen  {\fontname{Courier}\cup}  und  {\fontname{Courier}\cap}  heisst ein  {\bfBoolescher Verband} , wenn folgende 
% Axiome gelten:
%
% (B1a)    a\capb = b\capa                                    Kommutativgesetz fr \cap  %<'FontName',MSVFORMFONT>
% (B1b)    a\cupb = b\cupa                                    Kommutativgesetz fr \cup  %<'FontName',MSVFORMFONT>
% (B2a)    (a\capb)\cupc = (a\cupc)\cap(b\cupc)                       Distributivgesetz  %<'FontName',MSVFORMFONT>
% (B2b)    (a\cupb)\capc = (a\capc)\cup(b\capc)                       Distributivgesetz  %<'FontName',MSVFORMFONT>
% (B3a)    \forall a\inB  \exists I\inB , so dass  a\capI = a              Existenz des Einselements %<'FontName',MSVFORMFONT>
% (B3b)    \forall a\inB  \exists O\inB , so dass  a\cupO = a              Existenz des Nullelements %<'FontName',MSVFORMFONT>
% (B4)     \forall a\inB  \exists a'\inB, so dass  a\capa'= O , a\cupa' = I  Existenz des Komplements %<'FontName',MSVFORMFONT>
%
%
% Aus obigen Axiomen lassen sich eine Reihe von Gesetzen ableiten:
%
%
% (B5a)    Es gibt genau ein Nullelement  %<'FontName',MSVFORMFONT>
% (B5b)    Es gibt genau ein Einselement  %<'FontName',MSVFORMFONT>
% (B6)     Zu jedem  a\inB  gibt es genau ein Komplement  a'\inB  %<'FontName',MSVFORMFONT>
% (B7)     (a')' = a  %<'FontName',MSVFORMFONT>
% (B8a)    I' = O  %<'FontName',MSVFORMFONT>
% (B8b)    O' = I  %<'FontName',MSVFORMFONT>
% (B9)     a = b  genau dann, wenn  a' = b'  %<'FontName',MSVFORMFONT>
% (B10a)   a\capO = O  %<'FontName',MSVFORMFONT>
% (B10b)   a\cupI = I  %<'FontName',MSVFORMFONT>
% (B11a)   a\capa = a  %<'FontName',MSVFORMFONT>
% (B11b)   a\cupa = a  %<'FontName',MSVFORMFONT>
% (B12a)   (a\capb)\capc = a\cap(b\capc)                   Assoziativgesetz fr \cap  %<'FontName',MSVFORMFONT>
% (B12b)   (a\cupb)\cupc = a\cup(b\cupc)                   Assoziativgesetz fr \cup  %<'FontName',MSVFORMFONT>
% (B13a)   (a\capb)' = a'\cupb'                       Theorem von de Morgan  %<'FontName',MSVFORMFONT>
% (B13b)   (a\cupb)' = a'\capb'                       Theorem von de Morgan  %<'FontName',MSVFORMFONT>
% (B14a)   a\cup(a\capb) = a                          Verschmelzungsgesetz  %<'FontName',MSVFORMFONT>
% (B14b)   a\cap(a\cupb) = a                          Verschmelzungsgesetz  %<'FontName',MSVFORMFONT>
% (B15a)   a\cup(a'\capb) = a\cupb  %<'FontName',MSVFORMFONT>
% (B15b)   a\cap(a'\cupb) = a\capb  %<'FontName',MSVFORMFONT>
%
% Wir werden fortan nur den Booleschen Verband mit den zwei Elementen   {\fontname{Courier}O = 0}   und  
% {\fontname{Courier}I = 1}   betrachten.  Fr die Inversion  {\fontname{Courier}a'}  von  {\fontname{Courier}a}  benutzen wir als Postfixsymbol 
% den Apostroph, weil das satztechnisch einfach ist.  Hufig wird statt dessen der 
% Oberstrich verwendet, seltener das Prfixsymbol  {\fontname{Courier}\neg} .  Die Syntax in Programmiersprachen 
% ist wiederum anders.  In MATLAB werden folgende Symbole benutzt:
%
% Boolesches Symbol:    \cap (Infix)     \cup (Infix)     ' (Postfix) %<'FontName',MSVFORMFONT>
% MATLAB-Symbol:        & (Infix)      | (Infix)     ~ (Prfix) %<'FontName',MSVFORMFONT>
%
% Zustzlich gibt es meistens Funktionen mit blicher Prfixschreibweise, in MATLAB z.B.  
% die Funktionen  {\fontname{Courier}and} ,  {\fontname{Courier}or}  und  {\fontname{Courier}not} .  So kann man alternativ notieren:
% 
a = 0
b = 1
c = 0
x1 = a | (b & (~c))                 % Infixnotation
x2 = or( a , and( b , not(c) ) )    % Prfixnotation
x3 = or( a , b & not(c) )           % Kombination
%
% blicherweise gelten die Przedenzregeln  {\fontname{Courier}NICHT}  vor  {\fontname{Courier}UND}  vor  {\fontname{Courier}ODER} , so dass man 
% den Ausdruck fr  {\fontname{Courier}x1}  ohne Klammern schreiben kann:   {\fontname{Courier}x1 = a\cupb\capc'} .   In MATLAB 
% bekommt man aber eine Warnung:
% 
a = 0;  b = 1;  c = 0;
x1 = a | b & ~c                     % Infixnotation
%
%
% Die MATLAB-Funktion  {\fontname{Courier}binexp2bintab}  berechnet einen als Textstring in 
% MATLAB-Syntax vorliegenden Ausdruck fr smtliche mglichen Kombinationen 
% der binren Variablen:
%
help binexp2bintab
%
% Ein Beispiel ist 
%
binexp2bintab('(a|b) & (~1|c) & (0|c)', {'a'; 'b'; 'c'})
%
% Mchte man die Identitt mit einem anderen Ausdruck berprfen ohne formale 
% Umformung unter Benutzung der Gesetze des Booleschen Verbandes oder mchte 
% man eine solche Umformug verifizieren, so geht das auch mit  {\fontname{Courier}binexp2bintab} :
%
tabelle1 = binexp2bintab('(a|b) & (~1|c) & (0|c)', {'a'; 'b'; 'c'})
tabelle2 = binexp2bintab('(a|b) & c', {'a'; 'b'; 'c'})
identisch = all(tabelle1==tabelle2)         % berprfung der Gleichheit
%
% Auf diese Weise lassen sich z.B. alle aus dem Booleschen Verband hergeleiteten 
% Gesetze berprfen.  Fr das erste Assoziativgesetz sieht es wie folgt aus:
%
linkeseite  = binexp2bintab('(a&b)&c', {'a'; 'b'; 'c'})
rechteseite = binexp2bintab('a&(b&c)', {'a'; 'b'; 'c'})
identisch   = all(linkeseite==rechteseite)  % berprfung der Gleichheit
%
% Nimmt man die quivalenz mit dem Infixsymbol  {\fontname{Courier}==}  hinzu, so geht es noch 
% einfacher:
%
identisch = all(binexp2bintab('(a&b)&c == a&(c&d)', {'a'; 'b'; 'c'}))
%

