%
%
%7.3.5  Transformation der Beschreibungen%<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-10,'Color',MSVTITLCOLOR>
%
%
%
% Die im vorangegangenen Abschnitt eingefhrten Basisfunktionen  {\fontname{Courier}p_i}  spannen 
% ebenso wie die Minterme (=Einspunktfunktionen) den  {\fontname{Courier}T_n}  auf.  Deshalb gibt 
% es eine lineare Transformation
%
% r = A*f    %<'FontName',MSVFORMFONT>
%
% zwischen den Komponentenvektoren  {\fontname{Courier}r}  und  {\fontname{Courier}f}  der gegebenen Schaltfunktion.
% Die binre Matrix  {\fontname{Courier}A}  kann hergeleitet werden aus den Funktionstabellen der
% Basisfunktionen der Reed-Muller-Form.  Wir schreiben diese Funktionstabellen 
% der Reihe nach als Spalten in eine Matrix und erhalten fr eine, zwei, drei Variablen:
%
variable = {'a'}                 % Bezeichner der Variablen
basis = rmbasis(variable)        % Basisfunktionen der Reed-Muller-Form
binexp2bintab3(basis,variable,2) % Funktionstabellen
%
variable = {'a';'b'}             % Bezeichner der Variablen
basis = rmbasis(variable)        % Basisfunktionen der Reed-Muller-Form
binexp2bintab3(basis,variable,2) % Funktionstabellen
%
variable = {'a';'b';'c'}         % Bezeichner der Variablen
basis = rmbasis(variable)        % Basisfunktionen der Reed-Muller-Form
binexp2bintab3(basis,variable,2) % Funktionstabellen
%
% Die binre Matrix  {\fontname{Courier}A}  hat offenbar eine sehr einfache Struktur, die sich 
% rekursiv aufbauen lsst:
%% A wird im Kommandofenster ausgegeben!
A = 1     % Anfang:  einmal klicken
%
A = [ A  zeros(size(A)) ;  A  A ]  % dies wiederholt klicken
%
% Die Matrix entspricht dem Sirpinski-Dreieck, das ein einfaches Beispiel eines exakten 
% Fraktals ist:   
%
for k=1:8  demosirpinski(k); end
%
% Wir bentigen nirgends in diesem Skript Kenntnisse ber Fraktale.  Dennoch nehmen 
% wir dieses Beispiel als Anlass zur Erluterung.  Die Anzahl  {\fontname{Courier}Z}  der Einsen nimmt bei der 
% Verdopplung der Spalten- bzw. Zeilenzahl der Matrix  {\fontname{Courier}A}  nicht mit einer Potenz von  {\fontname{Courier}2}  
% zu wie dies bei Lngen, Flchen und Rauminhalten der Fall ist (Dimension = 1, 2 bzw. 3), 
% sondern nach
%
% {\fontname{Courier}Z(2m) = 3 Z(m) = 2^d Z(m)}    mit     {\fontname{Courier}d = ln(3) / ln(2) = 1.585}
%
% Die Dimension  {\fontname{Courier}d}  ist also gebrochen, daher die Bezeichnung {\bfFraktal}.
%
% Die Matrix  A  ist zu sich selbst invers.  Wir beweisen dies durch Induktion:
%
% (1)  Fr  {\fontname{Courier}0}  Variable gilt  {\fontname{Courier}A^{(0)} = 1}  und folglich  {\fontname{Courier}A^{(0)}*A^{(0)} = 1} .
% Die Behauptung gilt also fr diesen Fall.
%
% (2)  Die Behauptung gelte fr  {\fontname{Courier}n}  Variable, also ist  {\fontname{Courier}A^{(n)}*A^{(n)} = I} , wo {\fontname{Courier}I}
% eine Einheitsmatrix entsprechender Grsse ist.  Dann hat  {\fontname{Courier}A^{(n+1)}}  die vier 
% Blockmatrizen
%
% A^{(n)}  O                         %<'FontName',MSVFORMFONT>
% A^{(n)}  A^{(n)}                   %<'FontName',MSVFORMFONT>
%
% Diese Matrix mit sich selbst multipliziert ergibt die Blockmatrizen
%
% A^{(n)}*A^{(n)}    O               %<'FontName',MSVFORMFONT>
% O           A^{(n)}*A^{(n)}        %<'FontName',MSVFORMFONT>
%
% Die Blockmatrizen auf der Hauptdiagonalen sind wegen der Induktionsvorausssetzung 
% Einheitsmatrizen.  Also ist auch die gesamte Matrix eine Einheitsmatrix.  Damit
% ist die behauptung fr alle natrlichen  {\fontname{Courier}n}  bewiesen.
%
% Als Konsequenz ergit sich, dass sowohl
%
% r = A*f    %<'FontName',MSVFORMFONT>
%
% wie auch
%
% f = A*r    %<'FontName',MSVFORMFONT>
%
% gilt.
%
% Transformationen zwischen den verschiedenen Darstellungen knnen in Handarbeit 
% nach oben beschriebenem Verfahren durchgefhrt werden.  Einfacher ist die
% Benutzung der folgenden Funktionen
%
help binexp2bintab3
%
help binexp2rmexp
%
help binexp2dnfexp
%
help binexp2knfexp
%
help binexp2rmexp
%
help bintab2bdd
%
help bintab2dnfexp
%
help bintab2knfexp
%
help bintab2rmexp
%
% Als Beispiel nehmen wir die Ermittlung von DNF, KNF und Reed-Muller-Form fr 
% eine als schaltalgebraischer Ausdruck gegebene Funktion mit {\fontname{Courier}NICHT (~)} , 
% {\fontname{Courier}UND (&)} , {\fontname{Courier}ODER (|)}  und  {\fontname{Courier}XOR (+)} :
%
f = 'c | (~a&b) | c+d';    % Funktion durch Ausdruck gegeben
v = {'a';'b';'c';'d'};     % benutzte Variablen
d = binexp2dnfexp(f,v)     % die DNF
k = binexp2knfexp(f,v)     % die KNF
d = binexp2rmexp(f,v)      % die Reed-Muller-Form
%
% Auch der Binrbaum lsst sich einfach darstellen:
%
t = binexp2bintab3(f,v);   % Funktionstabelle
bintreegraph(reducebintree(bintab2bintree(t)),v)
%