%
%
%7.4.2  Disjunktive Minimalform %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Gegeben sei eine Schaltfunktion als Ausdruck in disjunktiver Normalform, z.B.
%
% f(a,b,c) = a'\capb'\capc' \cup a'\capb'\capc \cup a'\capb\capc \cup a\capb\capc' %<'FontName',MSVFORMFONT>
%
% Unter Anwendung des Distributivgesetzes folgt hieraus
%
% f(a,b,c) = a'\capb'\cap(c' \cup c) \cup a'\capb\capc \cup a\capb\capc'           %<'FontName',MSVFORMFONT>
%
% oder
%
% f(a,b,c) = a'\capb'\capc' \cup a'\cap(b' \cup b)\capc \cup a\capb\capc'          %<'FontName',MSVFORMFONT>
%
% Wegen   {\fontname{Courier}(x' \cup x) = 1}   kann man dies weiter vereinfachen zu
%
% f(a,b,c) = a'\capb' \cup a'\capb\capc \cup a\capb\capc'                          %<'FontName',MSVFORMFONT>
%
% bzw.
%
% f(a,b,c) = a'\capb'\capc' \cup a'\capc \cup a\capb\capc'                         %<'FontName',MSVFORMFONT>
%
% Tatschlich kann man beide Zusammenfassungen zugleich vornehmen, wenn man 
% den Minterm, der in beiden Zusammenfassungen vorkommt doppelt schreibt unter 
% Ausnutzung des Gesetzes    {\fontname{Courier}a = a \cup a}  :
%
% f(a,b,c) = a'\capb'\capc' \cup a'\capb'\capc \cup a'\capb\capc \cup a\capb\capc'                    %<'FontName',MSVFORMFONT>
%
%          = a'\capb'\capc' \cup a'\capb'\capc \cup a'\capb'\capc \cup a'\capb\capc \cup a\capb\capc' %<'FontName',MSVFORMFONT>
%
%          = a'\capb'\cap(c' \cup c) \cup a'\cap(b' \cup b)\capc \cup a\capb\capc'                    %<'FontName',MSVFORMFONT>
%
%          = a'\capb' \cup a'\capc \cup a\capb\capc'                                                  %<'FontName',MSVFORMFONT>
%
% Das Ausklammern ist hufig bei mehr als zwei Termen mglich.  Zur Vereinfachung 
% des disjunktiven Ausdrucks kommt es, wenn die verbleibende Klammer  {\fontname{Courier}1}  ergibt.  
% Das ist genau dann der Fall, wenn die Klammer in ODER-Verknpfung smtliche  {\fontname{Courier}2^k}  
% Bitkombinationen von den  {\fontname{Courier}k}  in der Klammer vorkommenden Variablen enthlt, z.B.
%
%a'\capb' \cup a'\capb \cup a\capb' \cup a\capb  =  a'\cap(b'\cupb) \cup a\cap(b'\cupb)  =  a'\cupa  =  1 %<'FontName',MSVFORMFONT>
%
% oder 
%
%a'\capb'\capc' \cup a'\capb\capc' \cup a\capb'\capc' \cup a\capb\capc' \cup a'\capb'\capc \cup a'\capb\capc \cup a\capb'\capc \cup a\capb\capc %<'FontName',MSVFORMFONT>
%
%=  a'\cap(b'\cupb)\capc' \cup a\cap(b'\cupb)\capc' \cup a'\cap(b'\cupb)\capc \cup a\cap(b'\cupb)\capc %<'FontName',MSVFORMFONT>
%
%=  (a'\cupa)\capc' \cup (a'\cupa)\capc  = c' \cup c  =  1 %<'FontName',MSVFORMFONT>
%
% {\fontname{Courier}2^k}  Minterme, die auf diese Weise zu einem Term zusammenzufassen sind, liefern die  {\fontname{Courier}1}  
% als Funktionswert fr  {\fontname{Courier}2^k}  Bitkombinationen der Variablen, die zusammen einen einschrittigen 
% Code ergeben.  Die Vereinfachung kann man deshalb allein aufgrund der Funktionstabelle 
% vornehmen.  Im folgenden Beispiel einer Funktionstabelle lassen sich die ersten beiden 
% sowie die letzten vier Einspunkte jeweils zusammenfassen, da die zugehrigen Bitmuster 
% der Variablen einen einschrittigen Code bilden:
%
% a b c  |  f             %<'FontName',MSVFORMFONT>
% \_\_\_\_\_\_\_|\_\_\_\_ %<'FontName',MSVFORMFONT>
% 0 0 0  |  1             %<'FontName',MSVFORMFONT>
% 0 0 1  |  0             %<'FontName',MSVFORMFONT>
% 0 1 0  |  0             %<'FontName',MSVFORMFONT>
% 0 1 1  |  0             %<'FontName',MSVFORMFONT>
% 1 0 0  |  1             %<'FontName',MSVFORMFONT>
% 1 0 1  |  1             %<'FontName',MSVFORMFONT>
% 1 1 0  |  1             %<'FontName',MSVFORMFONT>
% 1 1 1  |  1             %<'FontName',MSVFORMFONT>
%
% Hieraus kann man unmittelbar die disjunktive Minimalform herleiten:
%
% f(a,b,c) = b'\capc' \cup a    %<'FontName',MSVFORMFONT>
%
% Das nach Karnaugh und Veitch benannte KV-Diagramm stellt die Funktionstabelle so dar, 
% dass zusammenfassbare Terme benachbart sind.  Das Diagramm entsteht durch ebene 
% Darstellung eines n-dimensionalen Wrfels.  Die folgende Demonstration zeigt den 
% bergang vom  dreidimensionalen Wrfel zum entsprechenden KV-Diagramm.  
%
demokvdiagram
%
% Man beachte, dass die Nachbarschaft zyklisch ist, d.h. das usserte linke Feld einer
% Zeile ist benachbart mit dem usserten rechten Feld der selben Zeile.  Das gilt 
% entsprechend auch fr Spalten.
%
% Das Diagramm wird zustzlich beschriftet mit allen Variablen.  Balken deuten dabei 
% an, wo die jeweilige Variable den Wert  1  hat.  Die folgenden Bilder zeigen einige 
% Beispiele fr den Fall von Schaltfunktionen mit drei Variablen. 
%
kvdiagram('(u&~v)|~w',{'u';'v';'w'})
%
kvdiagram([0 1 1 0 0 0 1 1],{'a';'b';'c'})
%
kvdiagram([1 0 1 1 0 0 1 0],{'x_1';'x_2';'x_3'})
%
% Die Diagramme fr zwei und eine Variable sind entsprechend einfacher. 
%
kvdiagram('(u&~v)',{'u';'v'})
%
kvdiagram([1 0])
%
% Im Diagramm fr 4 Variable bilden die 4 Ecken einen Unterraum.  Wenn die 
% Schaltfunktion durchweg eine  1  in diesen Feldern hat, kann man den Ausdruck 
% entsprechen vereinfachen.
%
kvdiagram([1 0 1 0 1 0 0 0 1 0 0 0 1 0 0 1])
%
% Das Minimieren der disjunktiven Form erfolgt durch Festlegung von maximalen 
% Unterrumen, in denen smtliche Funktionswerte gleich  1  sind.  Diese 
% Unterrume drfen sich berlappen.  Die Anzahl der zur berdeckung smtlicher 
% Einspunkte der Schaltfunktion erforderlichen Unterrume ist die Anzahl der 
% in der disjunktiven Minimalform verbleibenden Terme.  Die gewhlten Unterrume
% heissen {\bfSchleifen}, weil sie blicherweise auf Papier durch Einkreisen 
% definiert werden.
%
%% Durch Klicken auf einen Farb-Button in der Spalte "Schleifen" wird eine 
%% Schleife gewhlt.  Nun kann man die Zugehrigkeit von Punkten durch Anklicken 
%% ndern.  Weitere Schleifen werden mit der Taste "+" erzeugt.  Nach der Wahl 
%% von Schleifenmitgliedern kann man durch Klicken auf den Schleifenbutton
%% den entsprechenden Term sichtbar machen.  Mit der Taste "h" erhlt man bei 
%% fokussiertem Fenster weitere Hilfe.
%
%% Minimieren Sie nun als bung die folgenden Schaltfunktionen:
%
global KVMINEXP
kvdiagram([0 1 1 0 0 0 1 1],{'a';'b';'c'})
%
%% Prfen Sie das Resultat jeweils durch (1) Ausgabe der disjunktiven 
%% Minimalform mit der Taste "r" und(2) Anklicken der zugehrigen Prfroutine:
checkkvmin(KVMINEXP,[0 1 1 0 0 0 1 1],{'a';'b';'c'},4,2)
%
kvdiagram([1 0 0 1 1 0 0 0 1 0 1 0 1 0 1 0],{'a';'b';'c';'d'})
%
checkkvmin(KVMINEXP,[1 0 0 1 1 0 0 0 1 0 1 0 1 0 1 0],{'a';'b';'c';'d'},5,2)
%
kvdiagram([0 1 0 1 0 0 1 0 1 1 1 1 0 0 1 1],{'a';'b';'c';'d'})
%
checkkvmin(KVMINEXP,[0 1 0 1 0 0 1 0 1 1 1 1 0 0 1 1],{'a';'b';'c';'d'},5,3)
%
% Die Wahl der Schleifen ist nicht eindeutig.  Hufig gibt es mehrere 
% gleichwertige Lsungen wie das folgende Beispiel zeigt:
%
% Erste Lsung:
kvdiagram([0 1 0 1 1 1 1 0],{'a';'b';'c'},{[2 4] [6 5] [5 7]},2)
%
% Zweite Lsung:
kvdiagram([0 1 0 1 1 1 1 0],{'a';'b';'c'},{[2 4]  [6 2]  [5 7]},2)
%
%
% Die Minimierung von Schaltfunktionen mithilfe des KV-Diagramms bei mehr als
% 4  Variablen erfordert mehr Afmerksamkeit, da die Nachbarschaften eines 
% in die Ebene projizierten n-dimensionalen Wrfels mit  n>4  komplizierter 
% sind:
%
% Punkte sind benachbart, wenn sie im selben Teildiagramm benachbart sind 
% oder in benachbarten Teildiagrammen auf den selben Positionen liegen.
%
% Ein Beispiel mit  6  Variablen:
%
global KVMINEXP
f = [0 1 0 1 0 1 0 1 1 1 0 1 1 1 1 1 0 0 0 1 1 0 1 1 0 0 1 0 1 1 1 1];
f = [f 1 1 0 1 0 0 1 1 0 0 1 0 0 1 0 0 0 1 1 0 1 0 0 0 1 1 1 1 0 0 1 1];
v = {'a';'b';'c';'d';'e';'f'};
kvdiagram(f,v)
%
checkkvmin(KVMINEXP,f,v,54,15)
%