%
%
%7.4.5  Minimierung der Reed-Muller-Form %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-10,'Color',MSVTITLCOLOR>
%
%
%
% Auch bei einer Reed-Muller-Form kann man die Anzahl der im Ausdruck benutzten 
% Verknpfungen durch Ausklammern von Variablen verringern wie das folgende Beispiel 
% zeigt:
%
% f(a,b,c,d)  =  1 + b + a*b + a*d + a*b*c*d  =  1 + b + a*(d + b*(1 + c*d)) %<'FontName',MSVFORMFONT>
%
% Hufig gibt es mehrere gleichwertige Lsungen.  Eine weitere fr das obige 
% Beispiel ist:
%
% f(a,b,c,d)  =  1 + b + a*b + a*d + a*b*c*d  =  1 + b + a*(b + d*(1 + b*c)) %<'FontName',MSVFORMFONT>
%
% Durch das Ausklammern geht allerdings die ursprngliche Struktur der Reed-Muller-
% Form verloren.  Die besonderen Eigenschaften der Reed-Muller-Form basieren aber 
% gerade auf dieser Struktur.  Deshalb wird man diese Art der Minimierung nicht wollen 
% und die Reed-Muller-Form in der ursprnglichen Form belassen.
%
% Ist die zu realisierende Funktion aber nicht vollstndig spezifiziert, dann drfen die 
% Don't-Care-Punkte beliebig gesetzt werden.  Dies ermglicht die Eliminierung der 
% aufwendigsten Terme.  Wir betrachten hierzu die folgende Schaltfunktion von  
% 4  Variablen, die 5 Don't-Care-Punkte enthlt.  Anstelle der Sterne an den Don't-Care-
% Punkten der Funktionstabelle werden formale binre Variable  {\fontname{Courier}A, B, C, ...}  eingefhrt, 
% die so zu bestimmen sind, dass ausgewhlte Terme der Reed-Muller-Entwicklung 
% verschwinden.  In diesem Fall sind 5 Variable zu bestimmen, also bentigen wir 
% 5 Gleichungen.  Wir transformieren die Funktionstabelle mit den Unbekannten in 
% den Koeffizientenvektor der Reed-Muller-Form.  Das Resultat ist die vierte Spalte 
% des folgenden Bildes:
%
demominrm
%
% Die sechste Spalte des Bildes zeigt alle mglichen Terme der Reed-Muller-Form.
% Wir setzen versuchsweise die fnf aufwendigsten der nicht verschwindenden 
% Terme zu Null, um die erforderlichen Gleichungen zu erhalten. Sie knnen 
% linear abhngig oder widersprchlich sein.  Dann muss man einen eine andere 
% Wahl unter den von den Unbekannten abhngigen Termen treffen.  Die letzte 
% Spalte des Bildes zeigt den so erhaltenen Koeffizientenvektor der minimierten 
% Reed-Muller-Form.  Der zugehrige Ausdruck ist unten in rot angegeben. 
%
% {\fontname{Courier}demominrm}  hat als Parameter die Funktionstabelle mit den Werten  {\fontname{Courier}0}  und  {\fontname{Courier}1} 
% sowie  {\fontname{Courier}-1}  fr die Don't-Cares.  Die Funktion arbeitet mit Schaltfunktionen 
% von  {\fontname{Courier}1}  bis  {\fontname{Courier}6}  Variablen, die immer mit  {\fontname{Courier}a, b, c, ...}  bezeichnet werden.
% Nachfolgend werden einige Beispiele gegeben.
%
demominrm([0  0  0 -1  0  1  0  0])
%
demominrm([-1 -1 -1 -1  1  1  0  1  0  0 -1  1 -1 -1 -1  0])
%
clear f
f( 1:16) = [ 0 -1  1  0 -1  0  1  1  1 -1 -1  1  0 -1  0  1];
f(17:32) = [-1 -1 -1  1 -1  1  0  1 -1  1 -1  0  0  1 -1 -1];
demominrm(f)
%
clear f
f( 1:16) = [ 0  0  0  0  1  1  0  1  0  0  0  0  0  0  0  1];
f(17:32) = [ 0  1  0 -1  0  1 -1  0  1  1  1  0  0  0  0 -1];
f(33:48) = [ 0  1  0  0  0  1  1  1  0 -1 -1  0  0  1  0  1];
f(49:64) = [ 1  1  1  0 -1  0  1  1  1  1  1  1 -1  1  1  1];
demominrm(f)
%
% Das folgende Beispiel zeigt einen Fall, in dem viele Terme linear abhngig 
% oder paarweise widersprchlich sind.  In solchem Fall wird hier suboptimal 
% durch probieren nach einer Lsung gesucht:
%
demominrm([-1  0 -1  1  0  1  1  0  1  0 -1  0  1  0 -1  1])
%