%
%
%8.3.2  Hasards %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
%
% Wir betrachten das Zeitverhalten folgender Funktion:
%
f = '(a|b)&(~b|c )'
%
% Zunchst wandeln wir den Ausdruck in Prfix-Notation:
%
p = binexpr2prefix(f)
%
% Fr das Gattermodell weisen wir in der Reihenfolge des Auftretens der Verknpfungen
% im Ausdruck  p  diesen Verknpfungen je eine Verzgerung zu, z.B.
%
dly = [1 1 2]
%
% Dann ergibt sich fr ein zuflliges Inputmuster die rot dargestellte Ausgabe 
% der Funktion:
%
clear ip
for k=1:3  ip(k,:) = nfach(randb(50),10); end
drawdelay(f,dly,ip)
%
%% Wiederholen Sie dies mehrfach!
%% Die Ausgabe zeigt an einigen Stellen ein besonderes Verhalten.  Welches ?
%% Geben Sie die Bedingung an, unter der dies auftritt.
%
% Wir tauschen die Werte der Verzgerungen der beiden ODER-Glieder und erhalten:
%
dly = [1 2 1]
clear ip
for k=1:3 ip(k,:)=nfach(randb(50),10); end
drawdelay(f,dly,ip)
%
% Das merkwrdige Verhalten tritt nun an anderer Stelle auf.  Wann ?
%
% Wir benutzen jetzt das einfachste Signal, bei dem der Effekt auftritt:
%
dly = [1 1 2]
clear ip
ip = zeros(3,20);  ip(2,10:20) = 1;
drawdelay(f,dly,ip)
%
%
% Wir definieren:
%
% Ein  {\bfHasard}  ist die Eigenschaft einer Schaltfunktion bei bestimmten
% Kombinationen der individuellen Verzgerungen ihrer Verknpfungsglieder ein 
% Fehlverhalten zu zeigen.
%
% Ein  {\bfHasardfehler}  ist das aktuelle Fehlverhalten einer realisierten 
% Schaltfunktion aufgrund eines Hasards.
%
% \bfKlassifikation von Hasards
%
% (1)    nach der Erscheinungsform am Ausgang:
%
%         (1a)  statisch:   eigentlich soll sich gar nichts ndern
%
%         (1b)  dynamisch:  es soll eigentlich genau eine Flanke geben
%
% (2)    nach den Bedingungen am Eingang, unter denen sie auftreten:
%
%         (2a)  Ein  Strukturhasard  ist ein Hasard, der durch die Flanke 
%                 einer einzigen Eingangsvariablen auftritt. 
%
%         (2b)  Ein  Funktionshasard  ist ein Hasard, der erst bei zwei 
%                 gleichzeitigen Flanken von wenigstens zwei Eingangsvariablen 
%                 auftritt. 
%
% Nachfolgend sind die Erscheinungsformen abgebildet:
%
sigs = zeros(2,50);  sigs(2,25) = 1;
drawbinsigs(sigs,'statischer 1-Hasard',{'korrektes Signal';'Hasard'})
%
sigs = ones(2,50);  sigs(2,25) = 0;
drawbinsigs(sigs,'statischer 0-Hasard',{'korrektes Signal';'Hasard'})
%
sigs = [zeros(2,25) ones(2,25)];  sigs(2,27) = 0;
drawbinsigs(sigs,'dynamischer 0-Hasard',{'korrektes Signal';'Hasard'})
%
sigs = [ones(2,25) zeros(2,25)];  sigs(2,27) = 1;
drawbinsigs(sigs,'dynamischer 1-Hasard',{'korrektes Signal';'Hasard'})
%
% Strukturhasards treten schon bei einschrittigen nderungen des Inputsignals auf.
% Diese einschrittigen nderungen entsprechen den Nachbarschafts-Schritten im
% KV-Diagramm.  Schleifen sind als je ein Gatter realisiert.  Ein Schritt innerhalb 
% einer Schleife ndert also an keinem Gatterausgang etwas.  Fr einen Schritt 
% ausserhalb von Schleifen gilt das selbe.  Ein Schritt von einer Schleife zu 
% einer benachbarten Schleife ist kritisch.  Wenn nmlich das Gatter, welches 
% zunchst die 1 liefert, bei der Inputnderung schneller auf 0 schaltet als 
% das fr den neuen Input zustndige Gatter auf 1, dann geht die Ausgabe fr 
% die kurze bergangszeit auf Null.  Dadurch entsteht also ein statischer Hasard.
%
% Die Situation ist fr ein Beispiel nachfolgend dargestellt:
%
funktion = '(a&~b)|(b&c)';
kvdiagram(funktion,{'a';'b';'c'},{[6 5] [4 8]},1)
%
% Zwischen den Inputwerten  {\fontname{Courier}[a b c] = [1 0 1] \leftrightarrow [1 1 1]}  liegt ein Hasard vor.
% Wir prfen dies indem wir die Ausgabe bei diesen kritischen bergang fr 30 
% zufllige Kombinationen der Verzgerungen berechnen und die Bilder dann im 
% schnellen Wechsel anschauen:
%
sig = ones(3,25); sig(2,10:25) = 0;  % Inputsignale
for k=1:30  dly=floor(4*rand(1,3)), fh(k)=drawdelay(funktion,dly,sig); end
for k=1:120  figure(fh(1+mod(k,30))); pause(0.05); end
%
% Da es sich bei dem kritischen bergang um den bergang zwischen benachbarten 
% Einsen im KV-Diagramm handelt, kann man den Hasard beseitigen durch eine 
% zustzliche Schleife:
%
funktion = '(a&~b)|(b&c)|(a&c)';
kvdiagram(funktion,{'a';'b';'c'},{[6 5] [4 8] [6 8]},3)
%
% Tatschlich tritt kein Hasardfehler mehr auf:
%
sig = ones(3,25); sig(2,10:25) = 0;  % Inputsignale
for k=1:30  dly=floor(4*rand(1,4)), fh(k)=drawdelay(funktion,dly,sig); end
for k=1:120  figure(fh(1+mod(k,30))); pause(0.05); end
%
% Dieser Typ von Hasard heisst Struktur-Hasard, weil er durch strukturelle 
% Massnahmen bei der Realisierung beseitigt werden kann.  Die Funktionshasards,
% die bei nicht-einschrittigen bergngen auftreten, sind dagegen unvermeidlich.
%
