%
%
%9.2  Zeitglieder %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE,'Color',MSVTITLCOLOR>
%
%
% Bei nicht-getakteten Schaltwerken wird die Rckkopplung modelliert durch  
% Verzgerungen.  Das Verhalten solcher Schaltwerke sollte unabhngig von 
% Verzgerungen sein, da man diese aus technologischen Grnden nicht genau 
% festlegen kann.  Diese Forderung ist nur fr sehr einfache Flle erfllbar.
% Als wichtigste Beispiele besprechen wir die Flipflops im Kapitel 10.
%
% Bei getakteten Schaltwerken werden Speicher als Zeitglieder eingefgt. 
% Diese Speicher sind aus Flipflops aufgebaut.  Sie haben einen Daten-Eingang,
% einen Daten-Ausgang und einen Takt-Eingang.  Das Takt-Signal bestimmt, 
% wann der am Daten-Eingang anstehende Wert in den Speicher bernommen 
% wird und damit dann am Daten-Ausgang erscheint.  Es gibt unterschiedliche 
% Realisierungen, wie auf das Takt-Signal reagiert wird.  Wir definieren dazu:
%
% Definition:   Es sei   {\fontname{Courier}z : B \rightarrow R}   mit   {\fontname{Courier}z(0) = 0, z(1) = 1} .
% {\fontname{Courier}F \in S = \{ s | s : T \rightarrow B\}} ,   heisst  {\bfVorder}({\bfRck}){\bfflanke} (leading (trailing) edge) 
% von  {\fontname{Courier}x} , wo   {\fontname{Courier}T = R}   die Zeit bedeutet, wenn
%
% {\fontname{Courier}F(t) = 1}   falls   {\fontname{Courier}lim( z(x(t+\epsilon)) - z(x(t)) ) = 1  (-1)}
% {\fontname{Courier}              ^{\epsilon\rightarrow+0}}
% {\fontname{Courier}F(t) = 0}   sonst
%
% Das folgende Bild zeigt ein zuflliges Binrsignal und seine Vorder- und Rckflanken:
%
drawbinedge
%
% Definition:   Es gelte   {\fontname{Courier}c,x,y \in S = \{ s | s : T \rightarrow B\}}   und 
% {\fontname{Courier}F(t)}  sei Vorder- oder Rckflanke von  {\fontname{Courier}c} .  Dann heisst 
%
% g \in \{ f | f : S\timesS \rightarrow S\} %<'FontName',MSVFORMFONT>
%
% {\bftaktgesteuertes Zeitglied}  oder genauer {\bfVorder-} bzw. {\bfRckflanken-gesteuertes} 
% {\bfZeitglied}, wenn  {\fontname{Courier}y = g(x,c)}  mit  {\fontname{Courier}y(t) = x(\vartheta(t))} ,  wo
% 
% \vartheta(t) = MAX\{ \tau| \tau<t, F(\tau) = 1\} . %<'FontName',MSVFORMFONT>
%
% {\fontname{Courier}c}  heisst {\bfTakt}. 
%
% {\fontname{Courier}\vartheta(t)}  ist hier jeweils die Zeit der letzten Flanke vor  {\fontname{Courier}t} .  Dies wird anschaulich durch 
% das folgende Bild erlutert:
%
drawlastedge
%
% Das Verhalten eines Vorderflanken-gesteuerten Zeitgliedes wird in der folgenden 
% interaktiven Graphik gezeigt.  Die Zeit luft angedeutet durch den vertikalen 
% Balken kontinuierlich von links nach rechts.
%
%% Mit der linken Maustaste geben Sie das Taktsignal: Taste gedrckt entspricht 1.
taktdemo('+')      % Vorderflankengesteuertes Zeitglied
%
% Das selbe fr Rckflanken-Steuerung:
%
taktdemo('-')      % Rckflankengesteuertes Zeitglied
%
% Definition:   Es gelte  {\fontname{Courier}c,x,y \in S = \{ s | s : T \rightarrow B\}} .  {\fontname{Courier}V(t)}  und  {\fontname{Courier}R(t)}  
% sei Vorder- bzw. Rckflanke von  {\fontname{Courier}c} .  Dann heisst 
%
% {\fontname{Courier}g \in \{ f | f : S\timesS \rightarrow S\}} %<'FontName',MSVFORMFONT>
%
% {\bfpegelgesteuertes Zeitglied} (auch Zustands-gesteuertes Zeitglied), wenn  {\fontname{Courier}y = g(x,c)}  mit  
% {\fontname{Courier}y(t) = x(t)  }fr{\fontname{Courier}  c(t) = 1}   und   {\fontname{Courier}y(t) = x(\vartheta(t))}  sonst,  wo
% \vartheta(t) = MAX\{ \tau| \tau<t, R(\tau) = 1\} %<'FontName',MSVFORMFONT>
%
% und andererseits {\bfzweiflankengesteuertes Zeitglied}, wenn  {\fontname{Courier}y = g(x,c)}
% mit  {\fontname{Courier}y(t) = x(\vartheta(t))} , wo   {\fontname{Courier}\vartheta(t) = MAX\{ \tau | \tau<\Theta<t, V(\tau) = 1, R(\Theta) = 1\}} .
%
% In diesem Fall der Zweiflankensteuerung ist  {\fontname{Courier}\vartheta(t)}  der Zeitpukt der letzten Vorderflanke 
% vor der letzten Rckflanke.
%
% Die oben schon benutzte interaktive Demo arbeitet auch fr diese Taktsteuerungsarten:
%
taktdemo('p')      % Pegelgesteuertes Zeitglied
%
taktdemo('2')      % Zweiflankengesteuertes Zeitglied
%