%
%
%9.3  Beschreibung von Schaltwerken %<'FontWeight',MSVTITLWEIGHT,'FontSize',MSVTITLSIZE-6,'Color',MSVTITLCOLOR>
%
%
%
% Schaltwerke lassen sich beschreiben durch die Funktionstabellen fr die 
% berfhrungsfunktion und die Ausgabefunktion sowie Angaben ber die 
% Zeitglieder.  Im Falle von Schaltwerken sagen wir krzer:  {\bfbergangstabelle} 
% und {\bfAusgangstabelle}.
%
% Die Tabellen stellen jedoch nur eine Beschreibung der Schaltnetze dar.  Der 
% tatschliche zeitliche Ablauf kann nur mit Mhe aus der bergangstabelle 
% nachvollzogen werden.  Wesentlich bersichtlicher ist das sogenannte 
% Zustandsdiagramm.  Dies ist ein Graph, in dem jeder mgliche Zustand 
% des Schaltwerks durch einen Knoten dargestellt wird und jeder mgliche 
% bergang zwischen den Zustnden durch eine entsprechende Kante.  Die 
% Knoten werden passend benannt, die Kanten werden markiert durch diejenigen 
% Inputbitmuster, die zu dem bergang fhrt.
%
% Als einfaches Beispiel whlen wir einen 2-Bit-Binrzhler, der mit jedem 
% Zeitschritt die reprsentierte ganze Zahl um eins erhht modulo 4 .  Die 
% 4 Zustnde nennen wir A, B, C und D.  Da wir die Codierung des Zustandes 
% kennen, knnten wir als Bezeichnung auch  {\fontname{Courier}00, 01, 10, 11}  nehmen.  Wir 
% fhren noch eine Inputvariable ein, mit der der Zhler angehalten werden kann:
% {\fontname{Courier}x = 0}  bedeutet "Halt",  {\fontname{Courier}x = 1}  bedeutet "Zhlen".
%
n = 4; 
f = [1:n; 1+mod(1:n,n)]'
demofsm(f)
%% Mit der Taste  t (Takt) oder  c  (clock)  kann das Schaltwerk getaktet werden.
%% Der Input wird mit den Tasten  1, 2, ... gewhlt.  Hier bedeutet  1 :  x = 0;  2 :  x = 1 .
%
% Die bergangstabelle ist bei dieser Demo ebenfalls dargestellt und parallel 
% interaktiv.
%
%% In der bergangstabelle kann der Input in der Titelzeile angeklickt werden.
%% In der aktuellen Zusatndszeile kann einer der Folgezustde angeklickt werden.
%
% Bei Moore-Schaltwerken ist es blich, die Ausgabe zusammen mit der Knoten-
% bezeichnung in dem Knoten zu notieren.  Bei Mealy-Schaltwerken hngt die 
% Ausgabe vom Input ab.  Deshalb wird dann die Ausgabe neben der Input-
% bezeichnung an den Kanten notiert.  Wir lassen die Angabe der Ausgabe 
% meistens weg, da die Arbeitsweise des Schaltwerks allein durch die 
% berfhrungsfunktion bestimmt wird.
%
% Im folgenden Kapitel 10 werden die Flipflops als nichtgetaktete Schaltwerke 
% behandelt.  Das Kapitel 11 ist dann der Analyse und dem Entwurf von getakteten 
% Schaltwerken gewidmet.
%